//=============================================================================
// ANNACarcass
//
// Fixes some ammo bugs and cleans up the pickup messages
//=============================================================================
class ANNACarcass extends CBPCarcass;

var string invPickup[10]; //note that some mods use atypical belt slots

//thanks to Phillip J for this
function Frob(Actor Frobber, Inventory frobWith)
{
	local DeusExPlayer player;
	local DeusExWeapon weapon;
	local DeusExWeapon discovered_weapons_list;
	local DeusExWeapon discovered_weapons_list_iter;
	local DeusExWeapon discovered_weapons_list_iter_next;
	local Ammo         ammo;
	local Ammo         discovered_ammo_list;
	local Ammo         discovered_ammo_list_iter;
	local Ammo         discovered_ammo_list_iter_next;
	local Inventory    player_inventory_iter;
	local Inventory    carcass_inventory;
	local Inventory    carcass_inventory_iter;
	local Inventory    carcass_inventory_iter_next;
	local DeusExPickup pickup;
	local int max_bullets_able_to_hold_for_this_ammo;
	local int tmp;
	local int i;
	local bool collected_something;
	local string pickupMsg;
	
	if(bQueuedDestroy)
		return;
		
	if(!Frobber.IsA('DeusExPlayer'))
		return;
		
	collected_something = False;
	player = DeusExPlayer(Frobber);
	
	if(player != None)
	{	
		if(Inventory != None)
		{
			carcass_inventory = Inventory;
			carcass_inventory_iter = Inventory;
			
			// Iterate through the inventory of the carcass
			do
			{
				carcass_inventory_iter_next = carcass_inventory_iter.Inventory;
				
				// If the item is a stackable pickup (lockpick, medkit, etc)
				if((carcass_inventory_iter.IsA('DeusExPickup')) && (DeusExPickup(carcass_inventory_iter).bCanHaveMultipleCopies))
				{
					collected_something = True;
					pickup = DeusExPickup(player.FindInventoryType(carcass_inventory_iter.Class));
					
					if(pickup != None)
					{
						pickup.numCopies += DeusExPickup(carcass_inventory_iter).numCopies;
						
						if(pickup.numCopies > pickup.maxCopies)
							pickup.numCopies = pickup.maxCopies;
						
						AddInvToList(carcass_inventory_iter, DeusExPickup(carcass_inventory_iter).numCopies);
						DeleteInventory(carcass_inventory_iter);
						carcass_inventory_iter.Destroy();
						carcass_inventory_iter = None;
					}
					else if(player.FindInventorySlot(carcass_inventory_iter, false))
					{
						AddInvToList(carcass_inventory_iter);
						DeleteInventory(carcass_inventory_iter);
						carcass_inventory_iter.bInObjectBelt = False;
						carcass_inventory_iter.BeltPos = -1;
						carcass_inventory_iter.RespawnTime = 0.0;
						carcass_inventory_iter.SpawnCopy(player);
						carcass_inventory_iter = None;
					}
					else
					{
						DeleteInventory(carcass_inventory_iter);
						carcass_inventory_iter.Destroy();
						carcass_inventory_iter = None;
					}
				}
				// Otherwise, if the item is a weapon
				else if(carcass_inventory_iter.IsA('DeusExWeapon'))
				{
					weapon = DeusExWeapon(carcass_inventory_iter);
					
					if(discovered_weapons_list == None)
						discovered_weapons_list = weapon;
					else
						discovered_weapons_list_iter.Inventory = weapon;
					
					AddInvToList(carcass_inventory_iter);
					discovered_weapons_list_iter = weapon;
					discovered_weapons_list_iter.Inventory = None;
					DeleteInventory(weapon);
				}
				// Otherwise, if the item is ammo
				else if(carcass_inventory_iter.IsA('Ammo'))
				{
					ammo = Ammo(carcass_inventory_iter);
					
					if(discovered_ammo_list == None)
						discovered_ammo_list = ammo;
					else
						discovered_ammo_list_iter.Inventory = ammo;
					
					discovered_ammo_list_iter = ammo;
					discovered_ammo_list_iter.Inventory = None;
					DeleteInventory(ammo);
				}
				// Otherwise, delete whatever it was
				else
				{
					DeleteInventory(carcass_inventory_iter);
					carcass_inventory_iter.Destroy();
					carcass_inventory_iter = None;
				}
				
				carcass_inventory_iter = carcass_inventory_iter_next;
			}
			until((carcass_inventory_iter == None) || (carcass_inventory_iter == carcass_inventory));
		}
		
		// If we found some weapons
		if(discovered_weapons_list != None)
		{
			discovered_weapons_list_iter = discovered_weapons_list;
			
			// Iterate through what we've found
			do
			{
				discovered_weapons_list_iter_next = DeusExWeapon(discovered_weapons_list_iter.Inventory);
				
				// If we already have this weapon, just delete the one on the carcass
				weapon = DeusExWeapon(player.FindInventoryType(discovered_weapons_list_iter.Class));
				if(weapon != None)
				{
					discovered_weapons_list_iter.Destroy();
					discovered_weapons_list_iter = None;
				}
				
				// Otherwise, attempt to pick it up
				else if(player.FindInventorySlot(discovered_weapons_list_iter, false))
				{
					collected_something = True;
					discovered_weapons_list_iter.bInObjectBelt = False;
					discovered_weapons_list_iter.BeltPos = -1;
					discovered_weapons_list_iter.RespawnTime = 0.0;
					discovered_weapons_list_iter.PickupAmmoCount = 0;
					discovered_weapons_list_iter.SpawnCopy(player);
					discovered_weapons_list_iter = None;
				}
				
				// If we couldn't pick it up, then delete it
				else
				{
					discovered_weapons_list_iter.Destroy();
					discovered_weapons_list_iter = None;
				}
				
				discovered_weapons_list_iter = discovered_weapons_list_iter_next;
			}
			until((discovered_weapons_list_iter == None) || (discovered_weapons_list_iter == discovered_weapons_list));
		}
		
		// If we found some ammo
		if(discovered_ammo_list != None)
		{
			discovered_ammo_list_iter = discovered_ammo_list;
			
			// Iterate through what we've found
			do
			{
				discovered_ammo_list_iter_next = Ammo(discovered_ammo_list_iter.Inventory);
				
				// Only take the ammo if the amount is greater than zero
				if(discovered_ammo_list_iter.AmmoAmount > 0)
				{
					// Initially, we'll set the max ammo allowed to be carried at (AmmoType).default.AmmoAmount * 3.
					// This works out for 20mm and WP, but we'll do a paranoid check just in case there's an instance
					// where the weapon's PickupAmmoCount * 3 and (AmmoType).default.AmmoAmount * 3 aren't the same.
					// To do this, we'll search through the player's inventory for weapons.  If we find a weapon that
					// uses the same ammo type as the current looted ammo we're on, we'll check to see if the weapon's
					// PickupAmmoCount * 3 or ReloadCount * 3 are greater.  If they are, increase the max carry count.
					
					collected_something = True;
					max_bullets_able_to_hold_for_this_ammo = discovered_ammo_list_iter.default.AmmoAmount * 3;
					
					ammo = Ammo(player.FindInventoryType(discovered_ammo_list_iter.Class));
					if(ammo != None)
					{
						player_inventory_iter = player.Inventory;
						
						// Iterate player's inventory, looking for weapons
						do
						{
							if(player_inventory_iter.IsA('DeusExWeapon'))
							{
								weapon = DeusExWeapon(player_inventory_iter);
								if((weapon.AmmoName == ammo.Class) || (weapon.AmmoNames[0] == ammo.Class))
								{
									if(weapon.PickupAmmoCount > max_bullets_able_to_hold_for_this_ammo)
										max_bullets_able_to_hold_for_this_ammo = weapon.PickupAmmoCount;
									if(weapon.ReloadCount * 3 > max_bullets_able_to_hold_for_this_ammo)
										max_bullets_able_to_hold_for_this_ammo = weapon.ReloadCount * 3;
								}
							}
							player_inventory_iter = player_inventory_iter.Inventory;
						}
						until((player_inventory_iter == None) || (player_inventory_iter == player.Inventory))
						
						// Collect the ammo, capped at the max
						tmp = max_bullets_able_to_hold_for_this_ammo - ammo.AmmoAmount;
						if(discovered_ammo_list_iter.AmmoAmount < tmp)
							tmp = discovered_ammo_list_iter.AmmoAmount;
						ammo.AmmoAmount += tmp;
						
						// added by Cozmo (sorry for the hard-coding, dx lacks a 'secondary ammo' variable. Todo it?)
					//	if(Ammo(discovered_ammo_list_iter.Inventory).IsA('Ammo20mm') || Ammo(discovered_ammo_list_iter.Inventory).IsA('AmmoRocketWP') || Ammo(discovered_ammo_list_iter.Inventory).IsA('AmmoSabot'))
					//		DeusExPlayer(Frobber).ClientMessage("You found some " $ Ammo(discovered_ammo_list_iter.Inventory).AmmoName); //itemArticle is always "some" anyway
						
						discovered_ammo_list_iter.Destroy();
						discovered_ammo_list_iter = None;
					}
					else
					{
						// If we don't already have any of this ammo type, we'll just take it
						discovered_ammo_list_iter.RespawnTime = 0.0;
						discovered_ammo_list_iter.SpawnCopy(player);
						discovered_ammo_list_iter = None;
					}
				}
				
				// Otherwise, if the ammo had 0 left, delete it
				else
				{
					discovered_ammo_list_iter.Destroy();
					discovered_ammo_list_iter = None;
				}
				
				discovered_ammo_list_iter = discovered_ammo_list_iter_next;
			}
			until((discovered_ammo_list_iter == None) || (discovered_ammo_list_iter == discovered_ammo_list));
		}
	}
	
	// Show a brief message, give bio-energy, and destroy the carcass
	if(player != None)
	{
		if(collected_something)
		{
			//player.ClientMessage("You found some equipment");
			
			pickupMsg = "You found: ";
			
			for(i = 1; i < 10; i++)
			{
				if(invPickup[i] != "")
					pickupMsg = pickupMsg $ invPickup[i] $ ", ";
			}
			
			if(invPickup[0] != "")
				pickupMsg = pickupMsg $ invPickup[0] $ ", ";
				
			pickupMsg = Mid(pickupMsg, 0, Len(pickupMsg) - 2);
			player.ClientMessage(pickupMsg);
			PlaySound(Sound'WeaponPickup', SLOT_Interact);
		}
		else
			player.ClientMessage(msgEmpty);
		
		player.ClientMessage(Sprintf(msgRecharged, 25));
		PlaySound(Sound'BioElectricHiss', SLOT_None,,, 256);
		player.Energy += 25;
		if(player.Energy > player.EnergyMax)
			player.Energy = player.EnergyMax;
		
		bQueuedDestroy = True;
		Destroy();
	}
}

//monstrosity by Cozmo
function AddInvToList(Inventory inv, optional int quantity)
{
	local int invLoc;
	local int i;
	local string tempStr;
	
	for(i = 0; i < 10; i++)
	{
		if(invPickup[i] == "")
		{
			if(inv.TestMPBeltSpot(i))
			{
				tempStr = inv.itemName;
				
				//filter excessively long names. Yes I know this is terrible, I'll remove this once I've made the CDX nades and have full control over item names (packages)
				if(Len(tempStr) > 15)
				{
					if(tempStr == "Electromagnetic Pulse (EMP) Grenade")
						tempStr = "EMP Grenade";
					else if(tempStr == "Lightweight Attack Munitions (LAM)")
						tempStr = "LAM";
					else if(tempStr == "Bioelectric Cell")
						tempStr = "Biocell";
					//else if(tempStr == "Light Anti-Tank Weapon (LAW)")
					//	tempStr = "LAW";
				}
				
				if(quantity > 1)
					tempStr = quantity $ "x " $ tempStr;
					
				invPickup[i] = tempStr;
				return;
			}
		}
	}
}

//unedited code
/*
function Frob(Actor Frobber, Inventory frobWith)
{
	local DeusExPlayer player;
	local DeusExWeapon weapon;
	local DeusExWeapon discovered_weapons_list;
	local DeusExWeapon discovered_weapons_list_iter;
	local DeusExWeapon discovered_weapons_list_iter_next;
	local Ammo         ammo;
	local Ammo         discovered_ammo_list;
	local Ammo         discovered_ammo_list_iter;
	local Ammo         discovered_ammo_list_iter_next;
	local Inventory    player_inventory_iter;
	local Inventory    carcass_inventory;
	local Inventory    carcass_inventory_iter;
	local Inventory    carcass_inventory_iter_next;
	local DeusExPickup pickup;
	local int max_bullets_able_to_hold_for_this_ammo;
	local int tmp;
	local bool collected_something;
	
	if(bQueuedDestroy)
		return;
	if(!Frobber.IsA('DeusExPlayer'))
		return;
		
	collected_something = False;
	
	player = DeusExPlayer(Frobber);
	if(player != None)
	{	
		if(Inventory != None)
		{
			carcass_inventory = Inventory;
			carcass_inventory_iter = Inventory;
			
			// Iterate through the inventory of the carcass
			do
			{
				carcass_inventory_iter_next = carcass_inventory_iter.Inventory;
				
				// If the item is a stackable pickup (lockpick, medkit, etc)
				if((carcass_inventory_iter.IsA('DeusExPickup')) && (DeusExPickup(carcass_inventory_iter).bCanHaveMultipleCopies))
				{
					collected_something = True;
					
					pickup = DeusExPickup(player.FindInventoryType(carcass_inventory_iter.Class));
					if(pickup != None)
					{
						pickup.numCopies += DeusExPickup(carcass_inventory_iter).numCopies;
						if(pickup.numCopies > pickup.maxCopies)
							pickup.numCopies = pickup.maxCopies;
						
						DeleteInventory(carcass_inventory_iter);
						carcass_inventory_iter.Destroy();
						carcass_inventory_iter = None;
					}
					else if(player.FindInventorySlot(carcass_inventory_iter, false))
					{
						DeleteInventory(carcass_inventory_iter);
						carcass_inventory_iter.bInObjectBelt = False;
						carcass_inventory_iter.BeltPos = -1;
						carcass_inventory_iter.RespawnTime = 0.0;
						carcass_inventory_iter.SpawnCopy(player);
						carcass_inventory_iter = None;
					}
					else
					{
						DeleteInventory(carcass_inventory_iter);
						carcass_inventory_iter.Destroy();
						carcass_inventory_iter = None;
					}
				}
				
				// Otherwise, if the item is a weapon
				else if(carcass_inventory_iter.IsA('DeusExWeapon'))
				{
					weapon = DeusExWeapon(carcass_inventory_iter);
					
					if(discovered_weapons_list == None)
						discovered_weapons_list = weapon;
					else
						discovered_weapons_list_iter.Inventory = weapon;
					
					discovered_weapons_list_iter = weapon;
					discovered_weapons_list_iter.Inventory = None;
					DeleteInventory(weapon);
				}
				
				// Otherwise, if the item is ammo
				else if(carcass_inventory_iter.IsA('Ammo'))
				{
					ammo = Ammo(carcass_inventory_iter);
					
					if(discovered_ammo_list == None)
						discovered_ammo_list = ammo;
					else
						discovered_ammo_list_iter.Inventory = ammo;
					
					discovered_ammo_list_iter = ammo;
					discovered_ammo_list_iter.Inventory = None;
					DeleteInventory(ammo);
				}
				
				// Otherwise, delete whatever it was
				else
				{
					DeleteInventory(carcass_inventory_iter);
					carcass_inventory_iter.Destroy();
					carcass_inventory_iter = None;
				}
				
				carcass_inventory_iter = carcass_inventory_iter_next;
			}
			until((carcass_inventory_iter == None) || (carcass_inventory_iter == carcass_inventory));
		}
		
		// If we found some weapons
		if(discovered_weapons_list != None)
		{
			discovered_weapons_list_iter = discovered_weapons_list;
			
			// Iterate through what we've found
			do
			{
				discovered_weapons_list_iter_next = DeusExWeapon(discovered_weapons_list_iter.Inventory);
				
				// If we already have this weapon, just delete the one on the carcass
				weapon = DeusExWeapon(player.FindInventoryType(discovered_weapons_list_iter.Class));
				if(weapon != None)
				{
					discovered_weapons_list_iter.Destroy();
					discovered_weapons_list_iter = None;
				}
				
				// Otherwise, attempt to pick it up
				else if(player.FindInventorySlot(discovered_weapons_list_iter, false))
				{
					collected_something = True;
					discovered_weapons_list_iter.bInObjectBelt = False;
					discovered_weapons_list_iter.BeltPos = -1;
					discovered_weapons_list_iter.RespawnTime = 0.0;
					discovered_weapons_list_iter.PickupAmmoCount = 0;
					discovered_weapons_list_iter.SpawnCopy(player);
					discovered_weapons_list_iter = None;
				}
				
				// If we couldn't pick it up, then delete it
				else
				{
					discovered_weapons_list_iter.Destroy();
					discovered_weapons_list_iter = None;
				}
				
				discovered_weapons_list_iter = discovered_weapons_list_iter_next;
			}
			until((discovered_weapons_list_iter == None) || (discovered_weapons_list_iter == discovered_weapons_list));
		}
		
		// If we found some ammo
		if(discovered_ammo_list != None)
		{
			discovered_ammo_list_iter = discovered_ammo_list;
			
			// Iterate through what we've found
			do
			{
				discovered_ammo_list_iter_next = Ammo(discovered_ammo_list_iter.Inventory);
				
				// Only take the ammo if the amount is greater than zero
				if(discovered_ammo_list_iter.AmmoAmount > 0)
				{
					// Initially, we'll set the max ammo allowed to be carried at (AmmoType).default.AmmoAmount * 3.
					// This works out for 20mm and WP, but we'll do a paranoid check just in case there's an instance
					// where the weapon's PickupAmmoCount * 3 and (AmmoType).default.AmmoAmount * 3 aren't the same.
					// To do this, we'll search through the player's inventory for weapons.  If we find a weapon that
					// uses the same ammo type as the current looted ammo we're on, we'll check to see if the weapon's
					// PickupAmmoCount * 3 or ReloadCount * 3 are greater.  If they are, increase the max carry count.
					
					collected_something = True;
					max_bullets_able_to_hold_for_this_ammo = discovered_ammo_list_iter.default.AmmoAmount * 3;
					
					ammo = Ammo(player.FindInventoryType(discovered_ammo_list_iter.Class));
					if(ammo != None)
					{
						player_inventory_iter = player.Inventory;
						
						// Iterate player's inventory, looking for weapons
						do
						{
							if(player_inventory_iter.IsA('DeusExWeapon'))
							{
								weapon = DeusExWeapon(player_inventory_iter);
								if((weapon.AmmoName == ammo.Class) || (weapon.AmmoNames[0] == ammo.Class))
								{
									if(weapon.PickupAmmoCount > max_bullets_able_to_hold_for_this_ammo)
										max_bullets_able_to_hold_for_this_ammo = weapon.PickupAmmoCount;
									if(weapon.ReloadCount * 3 > max_bullets_able_to_hold_for_this_ammo)
										max_bullets_able_to_hold_for_this_ammo = weapon.ReloadCount * 3;
								}
							}
							player_inventory_iter = player_inventory_iter.Inventory;
						}
						until((player_inventory_iter == None) || (player_inventory_iter == player.Inventory))
						
						// Collect the ammo, capped at the max
						tmp = max_bullets_able_to_hold_for_this_ammo - ammo.AmmoAmount;
						if(discovered_ammo_list_iter.AmmoAmount < tmp)
							tmp = discovered_ammo_list_iter.AmmoAmount;
						ammo.AmmoAmount += tmp;
						
						discovered_ammo_list_iter.Destroy();
						discovered_ammo_list_iter = None;
					}
					else
					{
						// If we don't already have any of this ammo type, we'll just take it
						discovered_ammo_list_iter.RespawnTime = 0.0;
						discovered_ammo_list_iter.SpawnCopy(player);
						discovered_ammo_list_iter = None;
					}
				}
				
				// Otherwise, if the ammo had 0 left, delete it
				else
				{
					discovered_ammo_list_iter.Destroy();
					discovered_ammo_list_iter = None;
				}
				
				discovered_ammo_list_iter = discovered_ammo_list_iter_next;
			}
			until((discovered_ammo_list_iter == None) || (discovered_ammo_list_iter == discovered_ammo_list));
		}
	}
	
	// Show a brief message, give bio-energy, and destroy the carcass
	if(player != None)
	{
		if(collected_something)
		{
			player.ClientMessage("You found some equipment");
			PlaySound(Sound'WeaponPickup', SLOT_Interact);
		}
		else
			player.ClientMessage(msgEmpty);
		
		player.ClientMessage(Sprintf(msgRecharged, 25));
		PlaySound(Sound'BioElectricHiss', SLOT_None,,, 256);
		player.Energy += 25;
		if(player.Energy > player.EnergyMax)
			player.Energy = player.EnergyMax;
		
		bQueuedDestroy = True;
		Destroy();
	}
}
*/

DefaultProperties
{
}
