//=============================================================================
// WeaponAssaultGun.
//=============================================================================
class CDXWeaponAssaultGun extends CDXWeapon;

function int GetWeaponDamageSkill(int userLevel, optional actor target)
{
	local float dist, shortRange;
	
	if(target != none)
		dist = VSize(target.Location - Owner.Location);
		
	shortRange = 80 + (userLevel * 80); //5 feet, extra 5 for each level

	if(dist > 0 && dist <shortRange) //0 = no distance used (was 440)
	{
		//broadcastmessage("short range!");
		
		if(userLevel == 0) //untrained (sp-only?)
			return 11;
		if(userLevel == 1) //trained
			return 13;
		if(userLevel == 2) //advanced
			return 15;
		if(userLevel == 3) //master
			return 18;
		if(userLevel == 4) //master + targ
			return 20;
	}
	else
	{
		if(userLevel == 0) //untrained (sp-only?)
			return 9;
		if(userLevel == 1) //trained
			return 10;
		if(userLevel == 2) //advanced
			return 12;
		if(userLevel == 3) //master
			return 14;
		if(userLevel == 4) //master + targ
			return 16; //was 15
	}
	
	
	//more detailed dropoff draft for future maybe... idk if close range and longer range differ enough to warrant this though...
	
	// max damage      scaled damage (%)        min damage           max range
	// |---------------|------------------------|--------------------|
	
//	if(target != none)
//	{
//		dist = VSize(target.Location - Owner.Location);
//		
//		//32uu = 1 foot
//		if(dist <= 160) //5 foot
//		{
//			//max dmg table
//		}
//		else if(dist >= 320) //10 foot, min damage
//		{
//			//min dmg table
//		}
//		else
//		{
//			//get damage between these values, based on distance. something like dist -= 160, then check against max range (- 160) as a percentage? (note: minus the min damage from max damage for the difference to get % of)
//		}
//	}
}

simulated function int GetWeaponSpreadMargin()
{
	//return 250; //a little better acc than vanilla
	return 260; //untested
}

simulated function float GetWeaponRecoilSkill(float userLevel)
{
	if(userLevel == 0) //untrained (sp-only?)
		return 0.65;
	if(userLevel == 1) //trained
		return 0.22;
	if(userLevel == 2) //advanced
		return 0;
	if(userLevel == 3) //master
		return 0;
	if(userLevel == 4) //master + targ
		return 0;
}

defaultproperties
{
	//burstShots=5
	//burstShotTime=0.1
    //ShotTime=0.600000
	recoilDuration=0.55
	lowClipCount=4
	burstDuration=0.5
	shotTime=0.1
	bringUpTime=0.44
	//gunAccuracy=0.07
	gunAccuracy=0.3
	bHasMuzzleFlash=false //temp
	//currentAccuracy=0.55 //this will cause the crosshair to indicate spread, but tbh it's not good...
     LowAmmoWaterMark=30
     GoverningSkill=Class'DeusEx.SkillWeaponRifle'
     EnviroEffective=ENVEFF_Air
     Concealability=CONC_Visual
     bAutomatic=True
     reloadTime=3.000000
     HitDamage=3
     BaseAccuracy=0.700000
     bCanHaveLaser=True
     bCanHaveSilencer=True
     AmmoNames(0)=Class'DeusEx.Ammo762mm'
     AmmoNames(1)=Class'DeusEx.Ammo20mm'
     ProjectileNames(1)=Class'CDX_140.CDXHECannister20mm'
     recoilStrength=0.500000
     MinWeaponAcc=0.200000
     mpReloadTime=0.500000
     mpHitDamage=9
     mpBaseAccuracy=1.000000
     mpAccurateRange=2400
     mpMaxRange=2400
     mpReloadCount=30
     bCanHaveModBaseAccuracy=True
     bCanHaveModReloadCount=True
     bCanHaveModAccurateRange=True
     bCanHaveModReloadTime=True
     bCanHaveModRecoilStrength=True
     AmmoName=Class'DeusEx.Ammo762mm'
     ReloadCount=30
     PickupAmmoCount=30
     bInstantHit=True
     FireOffset=(X=-16.000000,Y=5.000000,Z=11.500000)
     shakemag=200.000000
     FireSound=Sound'DeusExSounds.Weapons.AssaultGunFire'
     //FireSound=Sound'DeusExSounds.Weapons.HideAGunFire'
     AltFireSound=Sound'DeusExSounds.Weapons.AssaultGunReloadEnd'
     CockingSound=Sound'DeusExSounds.Weapons.AssaultGunReload'
     SelectSound=Sound'DeusExSounds.Weapons.AssaultGunSelect'
     InventoryGroup=4
     ItemName="Assault Rifle"
     ItemArticle="an"
     PlayerViewOffset=(X=16.000000,Y=-5.000000,Z=-11.500000)
     PlayerViewMesh=LodMesh'DeusExItems.AssaultGun'
     PickupViewMesh=LodMesh'DeusExItems.AssaultGunPickup'
     ThirdPersonMesh=LodMesh'DeusExItems.AssaultGun3rd'
     LandSound=Sound'DeusExSounds.Generic.DropMediumWeapon'
     Icon=Texture'DeusExUI.Icons.BeltIconAssaultGun'
     largeIcon=Texture'DeusExUI.Icons.LargeIconAssaultGun'
     largeIconWidth=94
     largeIconHeight=65
     invSlotsX=2
     invSlotsY=2
     Description="The 7.62x51mm assault rifle is designed for close-quarters combat, utilizing a shortened barrel and 'bullpup' design for increased maneuverability. An additional underhand 20mm HE launcher increases the rifle's effectiveness against a variety of targets."
     beltDescription="ASSAULT"
     Mesh=LodMesh'DeusExItems.AssaultGunPickup'
     CollisionRadius=15.000000
     CollisionHeight=1.100000
     Mass=30.000000
}
