//=============================================================================
// WeaponBaton.
//=============================================================================
class CDXWeaponBaton extends CDXWeapon;

var name lastAnim;

simulated function StartAtkAnim() //some code in here is borrowed from Lexi's DXW2!
{
	local float rnd, mult;
	local name anim;
	
	rnd = FRand();
	mult = 1;
	
	//randomly choose one. atk 2 is a copy of atk 1 in this model!
	if (rnd > 0.5)
		anim = 'Attack';
	else
		anim = 'Attack3';
			
	while(anim == lastAnim)
	{
		rnd = FRand();

		if (rnd > 0.5)
			anim = 'Attack';
		else
			anim = 'Attack3';
	}

//	if(anim == 'Attack3') //
//		mult *= 0.566666;
		
	if(anim == 'Attack' || anim == 'Attack2')
		mult = 1.44;
		
	mult *= 0.75;

	PlayAnim(anim,mult,0.1);
	PlaySound(FireSound);
	lastAnim = anim;
}

function int GetWeaponDamageSkill(int userLevel, optional actor target)
{	 
	if(userLevel == 0) //untrained (sp-only?)
		return 7;
	if(userLevel == 1) //trained
		return 10;
	if(userLevel == 2) //advanced
		return 12;
	if(userLevel == 3) //master
		return 14;
	if(userLevel == 4) //master + targ
		return 16;
		
	//vanilla values:
	//7	10	12	14
}

function name WeaponDamageType()
{
	return 'KnockedOut';
}

defaultproperties
{
	fireSoundRadius=1200
	atkDelayTime=0.45
	shotTime=0.78
	bringUpTime=0.9
     LowAmmoWaterMark=0
     GoverningSkill=Class'DeusEx.SkillWeaponLowTech'
     NoiseLevel=0.050000
     reloadTime=0.000000
     HitDamage=7
     maxRange=110
     mpMaxRange=110
     AccurateRange=110
     BaseAccuracy=1.000000
     bPenetrating=False
     bHasMuzzleFlash=False
     bHandToHand=True
     bFallbackWeapon=True
     bEmitWeaponDrawn=False
     AmmoName=Class'DeusEx.AmmoNone'
     ReloadCount=0
     bInstantHit=True
     FireOffset=(X=-24.000000,Y=14.000000,Z=17.000000)
     shakemag=20.000000
     FireSound=Sound'DeusExSounds.Weapons.BatonFire'
     SelectSound=Sound'DeusExSounds.Weapons.BatonSelect'
     Misc1Sound=Sound'DeusExSounds.Weapons.BatonHitFlesh'
     Misc2Sound=Sound'DeusExSounds.Weapons.BatonHitHard'
     Misc3Sound=Sound'DeusExSounds.Weapons.BatonHitSoft'
     InventoryGroup=24
     ItemName="Baton"
     PlayerViewOffset=(X=24.000000,Y=-14.000000,Z=-17.000000)
     PlayerViewMesh=LodMesh'DeusExItems.Baton'
     PickupViewMesh=LodMesh'DeusExItems.BatonPickup'
     ThirdPersonMesh=LodMesh'DeusExItems.Baton3rd'
     Icon=Texture'DeusExUI.Icons.BeltIconBaton'
     largeIcon=Texture'DeusExUI.Icons.LargeIconBaton'
     largeIconWidth=46
     largeIconHeight=47
     Description="A hefty looking baton, typically used by riot police and national security forces to discourage civilian resistance."
     beltDescription="BATON"
     Mesh=LodMesh'DeusExItems.BatonPickup'
     CollisionRadius=14.000000
     CollisionHeight=1.000000
}
