//=============================================================================
// WeaponCombatKnife.
//=============================================================================
class CDXWeaponCombatKnife extends CDXWeapon;

var name lastAnim;

simulated function StartAtkAnim() //all code in here is borrowed from Lexi's DXW2!
{
	local float rnd, mult;
	local name anim;
	
	rnd = FRand();
	mult = 1;
	
	//randomly choose one. Make sure they're the same speed!
	if (rnd < 0.33)
		anim = 'Attack';
	else if (rnd < 0.66)
		anim = 'Attack2';
	else
		anim = 'Attack3';
			
	while(anim == lastAnim) //added by Cozmo
	{
		rnd = FRand();
	
		if (rnd < 0.33)
			anim = 'Attack';
		else if (rnd < 0.66)
			anim = 'Attack2';
		else
			anim = 'Attack3';
	}
		
	if(anim == 'Attack')
		mult *= 0.91;
	else if(anim == 'Attack2')
		mult *= 1.364;

	PlayAnim(anim,mult,0.1);
	PlaySound(FireSound);
	lastAnim = anim;
}

function int GetWeaponDamageSkill(int userLevel, optional actor target)
{	 
	if(userLevel == 0) //untrained (sp-only?)
		return 20;
	if(userLevel == 1) //trained
		return 30;
	if(userLevel == 2) //advanced
		return 34;
	if(userLevel == 3) //master
		return 40;
	if(userLevel == 4) //master + targ
		return 45;
		
	//vanilla values:
	//20	30	34	40
}

defaultproperties
{
	fireSoundRadius=1200
	atkDelayTime=0.24
	shotTime=0.5
	bringUpTime=0.43
     LowAmmoWaterMark=0
     GoverningSkill=Class'DeusEx.SkillWeaponLowTech'
     NoiseLevel=0.050000
     EnemyEffective=ENMEFF_Organic
     Concealability=CONC_Visual
     reloadTime=0.000000
     HitDamage=5
     maxRange=110
     AccurateRange=110
     BaseAccuracy=1.000000
     bHasMuzzleFlash=False
     bHandToHand=True
     bFallbackWeapon=True
     mpHitDamage=20
     mpBaseAccuracy=1.000000
     mpAccurateRange=110
     mpMaxRange=110
     AmmoName=Class'DeusEx.AmmoNone'
     ReloadCount=0
     bInstantHit=True
     FireOffset=(X=-5.000000,Y=8.000000,Z=14.000000)
     shakemag=20.000000
     FireSound=Sound'DeusExSounds.Weapons.CombatKnifeFire'
     SelectSound=Sound'DeusExSounds.Weapons.CombatKnifeSelect'
     Misc1Sound=Sound'DeusExSounds.Weapons.CombatKnifeHitFlesh'
     Misc2Sound=Sound'DeusExSounds.Weapons.CombatKnifeHitHard'
     Misc3Sound=Sound'DeusExSounds.Weapons.CombatKnifeHitSoft'
     InventoryGroup=11
     ItemName="Combat Knife"
     PlayerViewOffset=(X=5.000000,Y=-8.000000,Z=-14.000000)
     PlayerViewMesh=LodMesh'DeusExItems.CombatKnife'
     PickupViewMesh=LodMesh'DeusExItems.CombatKnifePickup'
     ThirdPersonMesh=LodMesh'DeusExItems.CombatKnife3rd'
     Icon=Texture'DeusExUI.Icons.BeltIconCombatKnife'
     largeIcon=Texture'DeusExUI.Icons.LargeIconCombatKnife'
     largeIconWidth=49
     largeIconHeight=45
     Description="An ultra-high carbon stainless steel knife."
     beltDescription="KNIFE"
     Mesh=LodMesh'DeusExItems.CombatKnifePickup'
     CollisionRadius=12.650000
     CollisionHeight=0.800000
}
