//=============================================================================
// WeaponCrowbar.
//=============================================================================
class CDXWeaponCrowbar extends CDXWeapon;

var name lastAnim;

simulated function StartAtkAnim() //some code in here is borrowed from Lexi's DXW2!
{
	local float rnd, mult;
	local name anim;
	
	rnd = FRand();
	mult = 1;
	
	//randomly choose one. atk 2 is a copy of atk 1 in this model!
	if (rnd > 0.5)
		anim = 'Attack';
	else
		anim = 'Attack3';
			
	while(anim == lastAnim)
	{
		rnd = FRand();

		if (rnd > 0.5)
			anim = 'Attack';
		else
			anim = 'Attack3';
	}

	if(anim == 'Attack' || anim == 'Attack2')
		mult *= 0.85714;

	PlayAnim(anim,mult,0.1);
	PlaySound(FireSound);
	lastAnim = anim;
}

function int GetWeaponDamageSkill(int userLevel, optional actor target)
{	 
	if(userLevel == 0) //untrained (sp-only?)
		return 12;
	if(userLevel == 1) //trained
		return 18;
	if(userLevel == 2) //advanced
		return 20;
	if(userLevel == 3) //master
		return 24;
	if(userLevel == 4) //master + targ
		return 27;
		
	//vanilla values:
	//12 18 20 24
}

defaultproperties
{
	fireSoundRadius=1200
	atkDelayTime=0.33
	shotTime=0.55
	bringUpTime=0.33
     LowAmmoWaterMark=0
     GoverningSkill=Class'DeusEx.SkillWeaponLowTech'
     NoiseLevel=0.050000
     reloadTime=0.000000
     HitDamage=6
     maxRange=110
     AccurateRange=110
     BaseAccuracy=1.000000
     bPenetrating=False
     bHasMuzzleFlash=False
     bHandToHand=True
     bFallbackWeapon=True
     bEmitWeaponDrawn=False
     mpHitDamage=12
     mpBaseAccuracy=1.000000
     mpAccurateRange=110
     mpMaxRange=110
     AmmoName=Class'DeusEx.AmmoNone'
     ReloadCount=0
     bInstantHit=True
     FireOffset=(X=-40.000000,Y=15.000000,Z=8.000000)
     shakemag=20.000000
     FireSound=Sound'DeusExSounds.Weapons.CrowbarFire'
     SelectSound=Sound'DeusExSounds.Weapons.CrowbarSelect'
     Misc1Sound=Sound'DeusExSounds.Weapons.CrowbarHitFlesh'
     Misc2Sound=Sound'DeusExSounds.Weapons.CrowbarHitHard'
     Misc3Sound=Sound'DeusExSounds.Weapons.CrowbarHitSoft'
     InventoryGroup=10
     ItemName="Crowbar"
     PlayerViewOffset=(X=40.000000,Y=-15.000000,Z=-8.000000)
     PlayerViewMesh=LodMesh'DeusExItems.Crowbar'
     PickupViewMesh=LodMesh'DeusExItems.CrowbarPickup'
     ThirdPersonMesh=LodMesh'DeusExItems.Crowbar3rd'
     LandSound=Sound'DeusExSounds.Generic.DropMediumWeapon'
     Icon=Texture'DeusExUI.Icons.BeltIconCrowbar'
     largeIcon=Texture'DeusExUI.Icons.LargeIconCrowbar'
     largeIconWidth=101
     largeIconHeight=43
     invSlotsX=2
     Description="A crowbar. Hit someone or something with it. Repeat.|n|n<UNATCO OPS FILE NOTE GH010-BLUE> Many crowbars we call 'murder of crowbars.'  Always have one for kombat. Ha. -- Gunther Hermann <END NOTE>"
     beltDescription="CROWBAR"
     Mesh=LodMesh'DeusExItems.CrowbarPickup'
     CollisionRadius=19.000000
     CollisionHeight=1.050000
     Mass=15.000000
}
