//=============================================================================
// CDXWeaponFlamethrowerEXFR:
//=============================================================================
//   Experimental flamethrower, which uses modified fireballs that can bank off
//   of walls and inflict AOE damage without requiring direct projectile hits.
//=============================================================================
class CDXWeaponFlamethrowerEXFR extends CDXWeapon;

function int GetWeaponDamageSkill(int userLevel, optional actor target)
{	
	if(userLevel == 0) //untrained
		return 4;
	if(userLevel == 1) //trained
		return 4;
	if(userLevel == 2) //advanced
		return 5;
	if(userLevel == 3) //master
		return 6;
	if(userLevel == 4) //master + targ
		return 7;
}

simulated function float GetWeaponRecoilSkill(float userLevel)
{
	return 0;
}

defaultproperties
{
	bringUpTime=0.670000
	burstDuration=0.500000
	recoilDuration=0.000000
	LowAmmoWaterMark=50
	GoverningSkill=Class'DeusEx.SkillWeaponHeavy'
	EnviroEffective=ENVEFF_Air
	bAutomatic=True
	ShotTime=0.050000
	HitDamage=4
	maxRange=380
	AccurateRange=380
	BaseAccuracy=0.950000
	bHasMuzzleFlash=False
	AmmoName=Class'DeusEx.AmmoNapalm'
	ReloadCount=100
	PickupAmmoCount=100
	bInstantHit=False
	FireOffset=(Y=10.000000,Z=10.000000)
	ProjectileClass=Class'CDX_140.FireballEXFR'
	shakemag=0.000000
	shakevert=0.000000
	FireSound=Sound'DeusExSounds.Weapons.FlamethrowerFire'
	AltFireSound=Sound'DeusExSounds.Weapons.FlamethrowerReloadEnd'
	CockingSound=Sound'DeusExSounds.Weapons.FlamethrowerReload'
	SelectSound=Sound'DeusExSounds.Weapons.FlamethrowerSelect'
	InventoryGroup=15
	ItemName="Flamethrower"
	PlayerViewOffset=(X=20.000000,Y=-14.000000,Z=-12.000000)
	PlayerViewMesh=LodMesh'DeusExItems.Flamethrower'
	PickupViewMesh=LodMesh'DeusExItems.FlamethrowerPickup'
	ThirdPersonMesh=LodMesh'DeusExItems.Flamethrower3rd'
	LandSound=Sound'DeusExSounds.Generic.DropLargeWeapon'
	Icon=Texture'DeusExUI.Icons.BeltIconFlamethrower'
	largeIcon=Texture'DeusExUI.Icons.LargeIconFlamethrower'
	largeIconWidth=203
	largeIconHeight=69
	invSlotsX=4
	invSlotsY=2
	Description="A portable flamethrower that discards the old and highly dangerous backpack fuel delivery system in favor of pressurized canisters of napalm. Inexperienced agents will find that a flamethrower can be difficult to maneuver, however."
	beltDescription="FLAMETHWR"
	Mesh=LodMesh'DeusExItems.FlamethrowerPickup'
	CollisionRadius=20.500000
	CollisionHeight=4.400000
	Mass=40.000000
}