//=============================================================================
// WeaponGEPGun.
//=============================================================================
class CDXWeaponGEPGun extends CDXWeapon;

var localized String shortName;

function PostBeginPlay()
{
	Super.PostBeginPlay();

	// don't let NPC geps lock on to targets
	if ((Owner != None) && !Owner.IsA('DeusExPlayer'))
		bCanTrack = False;
}

function int GetWeaponDamageSkill(int userLevel, optional actor target)
{
	if(userLevel == 0) //untrained (sp-only?)
		return 150;
	if(userLevel == 1) //trained
		return 225;
	if(userLevel == 2) //advanced
		return 261;
	if(userLevel == 3) //master
		return 300;
	if(userLevel == 4) //master + targ
		return 342;
}

simulated function float GetWeaponRecoilSkill(float userLevel)
{
	if(userLevel == 0) //untrained (sp-only?)
		return 2;
	if(userLevel == 1) //trained
		return 0.8;
	if(userLevel == 2) //advanced
		return 0;
	if(userLevel == 3) //master
		return 0;
	if(userLevel == 4) //master + targ
		return 0;
}

//reloadcount of 12 is temp. set back to 1, and auto-reload!
defaultproperties
{
	recoilDuration=0.2
	ShotTime=3.2
	bringUpTime=1.0
	bInstantHit=false
    ReloadCount=1
	bHasScope=True
	altAmmoDelayTime=1.2
     ShortName="GEP Gun"
     LowAmmoWaterMark=4
     GoverningSkill=Class'DeusEx.SkillWeaponHeavy'
     NoiseLevel=2.000000
     EnviroEffective=ENVEFF_Air
     reloadTime=2.000000
     HitDamage=300
     maxRange=24000
     AccurateRange=14400
     bCanHaveScope=True
     bCanTrack=True
     LockTime=2.000000
     LockedSound=Sound'DeusExSounds.Weapons.GEPGunLock'
     TrackingSound=Sound'DeusExSounds.Weapons.GEPGunTrack'
     AmmoNames(0)=Class'DeusEx.AmmoRocket'
     AmmoNames(1)=Class'DeusEx.AmmoRocketWP'
     ProjectileNames(0)=Class'CDX_140.CDXRocket'
     ProjectileNames(1)=Class'CDX_140.CDXRocketWP'
     bHasMuzzleFlash=False
     recoilStrength=1.000000
     bUseWhileCrouched=False
     mpHitDamage=40
     mpAccurateRange=14400
     mpMaxRange=14400
     mpReloadCount=1
     bCanHaveModAccurateRange=True
     bCanHaveModReloadTime=True
     AmmoName=Class'DeusEx.AmmoRocket'
     PickupAmmoCount=4
     FireOffset=(X=-46.000000,Y=22.000000,Z=10.000000)
     ProjectileClass=Class'DeusEx.Rocket'
     shakemag=500.000000
     FireSound=Sound'DeusExSounds.Weapons.GEPGunFire'
     CockingSound=Sound'DeusExSounds.Weapons.GEPGunReload'
     SelectSound=Sound'DeusExSounds.Weapons.GEPGunSelect'
     InventoryGroup=17
     ItemName="Guided Explosive Projectile (GEP) Gun"
     PlayerViewOffset=(X=46.000000,Y=-22.000000,Z=-10.000000)
     PlayerViewMesh=LodMesh'DeusExItems.GEPGun'
     PickupViewMesh=LodMesh'DeusExItems.GEPGunPickup'
     ThirdPersonMesh=LodMesh'DeusExItems.GEPGun3rd'
     LandSound=Sound'DeusExSounds.Generic.DropLargeWeapon'
     Icon=Texture'DeusExUI.Icons.BeltIconGEPGun'
     largeIcon=Texture'DeusExUI.Icons.LargeIconGEPGun'
     largeIconWidth=203
     largeIconHeight=77
     invSlotsX=4
     invSlotsY=2
     Description="The GEP gun is a relatively recent invention in the field of armaments: a portable, shoulder-mounted launcher that can fire rockets and laser guide them to their target with pinpoint accuracy. While suitable for high-threat combat situations, it can be bulky for those agents who have not grown familiar with it."
     beltDescription="GEP GUN"
     Mesh=LodMesh'DeusExItems.GEPGunPickup'
     CollisionRadius=27.000000
     CollisionHeight=6.600000
     Mass=50.000000
}
