//====================================================================================
// DeusExWeapon version 2.0. (C)Lexichu, 2013-2017.
// Uses code from JimBowen of... is his forum dead now? - [dead site..?]
// Uses code from Dr. Dumb Lunatic of Deus Ex Editing - [dead site ;-;]
// Uses original code from DXSM - http://z6.invisionfree.com/TREM
// Uses heavily modified code from Ion Storm - http://www.square-enix.com/
//====================================================================================
class DeusExWeaponv2 expands DeusExWeapon
	abstract;

// -- Enums:
enum RCS
{
	RECOIL_Classic,
	RECOIL_ZeroAtMaster,
	RECOIL_Full
};

enum CSS
{
	COMSTR_Classic,
	COMSTR_Speed,
	COMSTR_PowSpeed
};

// -- Firing Variables:
var(DXW2) int coneSlugs;					// If we're using AOE_Cone, how many bullets/projectiles will a single shot pump out?
var(DXW2) int BurstShots;					// If we're a burst weapon, this is how many shots we will fire.
var(DXW2) float recoilTime;					// How long of the weapon's firing time will be used for recoiling?
var(DXW2) float ShotPenaltyMult;			// If this weapon has an accuracy penalty, this is the modifier for it.
var(DXW2) float ScopeDownDelay;				// The delay between firing the last shot of a clip, and the scope going down. Defaults to ShotTime.
var(DXW2) float RefireDelay;				// The absolute minimum delay between two shots/bursts.
var(DXW2) float TossDelay;					// The delay for single use weapons between firing, and destruction. (Multiplayer only.)
var(DXW2) float H2HDelay;					// The amount of the animation that plays for a hand-to-hand attack before firing. (0.0 to 1.0)
var(DXW2) bool bUseAccuracyPenalty;			// Does this weapon feature a per-shot accuracy penalty?
var(DXW2) bool bDestroyOnEmpty;				// Is this weapon destroyed when it is out of ammo? (Singleplayer)
var(DXW2) bool bMPDestroyOnEmpty;			// Is this weapon destroyed when it is out of ammo? (Multiplayer)

// -- Per-Ammo Variables:
var(DXW2) int ammoReload[3];				// Sets this weapon's clip size based on loaded ammo. Defaults to standard clip size.
var(DXW2) name ammoDamageType[3];			// Sets this weapon's bInstantHit = True damage type based on loaded ammo. Defaults to 'shot'.

// -- Sound/Display Variables:
var(DXW2) bool bAutoSoundPerShot;			// For those weapons that don't have a burst fire sound.
var(DXW2SFX) sound SilencedFire;			// Play a sound for each shot of an automatic burst as opposed to a blanket sound.
var(DXW2SFX) sound ManualRoundFeed;			// Sound when a round gets fed into the weapon using manual fed rounds.
var(DXW2SFX) bool bSoundToRange;			// Does this weapon play its sound throughout the entire range of its shot.

// -- Config File Variables:
var RCS RecoilSetting;				// Which recoil system to use - Classic DX, 0% recoil at Master in MP, or whatever crap I've coded it as by default.
var CSS CombatStrSetting;			// Whether Combat Strength should double damage, double swing speed, or both.
var bool bToggleLaser;				// Whether or not to use the traditional toggle laser.
var bool bShakeViewOn;				// Whether or not the view shakes ever so slightly when firing.
var bool bAutoLaser;					// Whether or not DXW2 should install capable weapons with lasers automatically.
var bool bVisibleLaser;				// Whether the laser point is visible to other players.
var bool bSwitchReload;				// Whether or not switching reloads weapons.
var bool bDuckAccBoost;				// Whether or not ducking increases accuracy.
var bool bQuickSwitch;				// Whether or not to use "quick switch" (disables any and all weapon up/down animation)
var bool bOldAccuDecay;				// Whether to use the old accuracy decay (standing increases accuracy for all weapons)
var bool bOldConeSpread;				// Whether shotguns are guaranteed at least one hit dead center.
var bool bReloadDownSniper;			// Whether weapons with a ReloadCount of 1 should be auto-reloaded during their downtime.
var bool bMLGDORITOS;				// Whether hitmarkers are enabled.
var bool bNerfPistolAcc;				// Disables pistol-sniping by giving a lower base accuracy.
var string HitM_Normal;				// Noise for a bodyshot.
var string HitM_Head;				// Noise for a headshot.
var string HitM_Texture;				// Texture for the hitmarker.
var bool bUseHDTP;					// Enable the use of HDTP models, if the user has them.

// -- Internal Variables:
var LaserPointer lSpot;						// Internal reference for the multiplayer Laser Sight dot.
var float curRecoilTime;					// Internal reference for how much Recoil Time has passed.
var int burstShotsFired;					// Internal reference for how many shots have been fired out of a full burst.
var bool bSelectFinished, bDownFinished;	// Internal reference for if the client has finished drawing or holstering their weapons.
var bool bReloadFinished;					// Internal reference for if the client has finished reloading.
var bool bReloadBegan, bReloadEnded;		// Internal reference for whether the client has finished the ReloadBegin and ReloadEnd animations.
var bool bCli_bFire;						// Internal reference for if the client is holding the Fire button.
var float saShotDelay;						// Internal reference for how much time the player has held LMB after firing.
var float downReloadDelay;					// Internal clock for reloading a deselected one-shot-reload weapon.
var bool bClientCantFire;					// Whether or not the server has finished with firing the weapon in question.
var bool bReplacedScope;					// Whether this weapon has replaced the player's scope or not.
var bool bLasing;							// If we are using the traditional laser; Is it active?
var float animFrames[4];					// The amount of frames in a non-standard mesh's animations.
var float animRates[4];						// The framerate of non-standard mesh animations.
var float placeTime;						// Shottime for placing a grenade.
var float FadeOutSeconds;					// Fade time for the hitmarkers.
var bool bHeadshotMarker;					// Red for headshots.
var bool bSS, bHSS;							// Played shot/headshot sound this tick. Hopefully will stop overwhelming Galaxy Sound Engine...
var Texture HMTex;							// Code-readable Texture class for hitmarker.
var string HDTP1st, HDTP3rd, HDTPPickup;	// Strings for HDTP models.
var bool bHasHDTP, bCheckedHDTP;			// RenderOverlays HDTP related checks; do we have, and have we checked for.

// -- Lock Variables:
var float StartLockTime, LockBrokeTime;		// A record of the last times that the lock was started, and broken.
var float LastTRKBeep, LastLCKBeep;			// Tracking the last Level.TimeSeconds that the weapons beeped somehow.
var Actor ACQTarget;						// Tracking the last target we... uhh... tracked.

// -- Rage inducing stuff.
var bool bNearWall;							// This won't replicate unless re-added.
var float standingTimer;					// Nor will this. :\
var bool bLockCFire, bLockH2HA;				// Fuck this coding language. 
											// (Lexi can't figure out how to get bClientCantFire off the client without going server>client>server (which takes 1 tick - too slow), so just set this at the same time.)

//--------------------------------
// I do not trust this engine to use PIDMAS/BODMAS/whatever the eff you want
// to mnemonic Order of Operations as...
// That much will become evident with my maths-related coding.
// ----------
// Reminder:
// Role == ROLE_Authority is Server talking to Client
// Role < ROLE_Authority is Client talking to Server
// bNetOwner is things that should only be replicated to the Owner.
//--------------------------------
replication
{
	reliable if (Role == ROLE_Authority)
		OwnerSwordNoise, AddRecoilTime, LockClientFiring, togDownState, togSelectState, togReloadState, SetClientAmmoParams2,
		ForceClientReload, standingTimer, bLasing, bNearWall, FadeOutSeconds, bHeadshotMarker, HMTex, bHSS, bSS, ResetHDTP, bUseHDTP;

	reliable if (Role == ROLE_Authority) // Config Variables get their own section because it's simpler for me to edit.
		RecoilSetting, bToggleLaser, bDuckAccBoost, bQuickSwitch, bOldAccuDecay, bMLGDORITOS;

	reliable if(Role < ROLE_Authority)
		SetAmmoProperties, SetReloadCount;

	reliable if (Role < ROLE_Authority && bNetOwner)
		PushWeaponSwitch, GetCli_bFire;

	unreliable if (Role < ROLE_Authority && bNetOwner)
		UpdateSpot;
}

/*----------------------------\\
|| Simulated Functions        ||
\\----------------------------*/

/*simulated event BeginState()
{
	Super.BeginState();
	BroadcastMessage(Name @ HumanNetmode(Level.Netmode) $" - " $GetStateName());
}*/

simulated event RenderOverlays( canvas Can )
{
	local int MarkerBrightness;
	local int iX, iY;
	local mesh tmpMesh;
	local pawn p;
	local DeusExRootWindow root;
	local DeusExPlayer DXP;

	Super.RenderOverlays(Can);
	DXP = DeusExPlayer(Owner);

	if(DXP != None)
	{
		if(!bCheckedHDTP && bUseHDTP && HDTP1st != "[NULL]")
		{
			tmpMesh = Mesh(DynamicLoadObject(HDTP1st, class'Mesh'));
			bHasHDTP = (tmpMesh != None);
			if(bHasHDTP)
			{
				Mesh = tmpMesh;
			}
			bCheckedHDTP = True;
			DXP.ClientMessage("Player has HDTPItems package:" @bHasHDTP);
		}
		
		//adw functionality added to ANNA adw
		/*
		root = DeusExRootWindow(DXP.rootWindow);
		if(root != None)
		{
			if(root.hud.AugDisplay.Class != Class'DXWeapon2.FixedADW')
			{
				DeusExPlayer(Owner).ClientMessage("Replaced" @root.hud.augdisplay.class @"with fixed Augmentation Display Window.");
				root.hud.AugDisplay.Destroy();
				root.hud.AugDisplay = FixedADW(root.Hud.NewChild(Class'DXWeapon2.FixedADW'));
				root.hud.augDisplay.SetWindowAlignments(HALIGN_Full, VALIGN_Full);
			}
		}
		*/

		if(bMLGDORITOS)
		{
			if(HMTex != None)
			{
				if(FadeOutSeconds < 0.0)
					FadeOutSeconds = 0.0;

				MarkerBrightness = FadeOutSeconds * 1275;
				Can.Style = 3;
				if(bHeadshotMarker || bHSS)
				{
					Can.SetPos((Can.SizeX / 2) - HMTex.uClamp * 0.75, (Can.SizeY / 2) - HMTex.vClamp * 0.75);
					Can.DrawColor.R = MarkerBrightness;
					Can.DrawColor.G = 0;
					Can.DrawColor.B = 0;
					Can.DrawTile(HMTex, HMTex.uClamp * 1.5, HMTex.vClamp * 1.5, 0, 0, HMTex.uClamp, HMTex.vClamp);
				}
				else
				{
					Can.SetPos((Can.SizeX / 2) - HMTex.uClamp * 0.5, (Can.SizeY / 2) - HMTex.vClamp * 0.5);
					Can.DrawColor.R = MarkerBrightness;
					Can.DrawColor.G = MarkerBrightness;
					Can.DrawColor.B = MarkerBrightness;
					Can.DrawTile(HMTex, HMTex.uClamp, HMTex.vClamp, 0, 0, HMTex.uClamp, HMTex.vClamp);
				}
			}
		}
	}
}

Simulated Function String HumanNetmode(int netID)
{
	switch(netID)
	{
		case 0: return "[Offline]";
		case 1: return "[Dedicated Server]";
		case 2: return "[Listen Server]";
		case 3: return "[Client]";
		default: return "[???]";
	}
}

simulated function SwapMuzzleFlashTexture()
{
	if (ScriptedPawn(Owner) != None) // Pawns always screw this up.
		return;
	else
		Super.SwapMuzzleFlashTexture();
}

simulated function bool LaserActiveCheck()
{
	return ((bToggleLaser && bHasLaser && bLasing) || (!bToggleLaser && bHasLaser));
}

simulated function ClientActive()
{
	if(ScriptedPawn(Owner) != None)
	{
		GotoState('Idle');
	}
	else
	{
		bWasInFiring = IsInState('ClientFiring') || IsInState('SimFinishFire');
		bClientReadyToFire = False;
		GotoState('SimActive');
	}
}

simulated function MuzzleFlashLight()
{
	local Vector offset, X, Y, Z;
	local PlayerPawn pp;
	local ScriptedPawn sp;

 	if (!bHasMuzzleFlash)
		return;

	pp = PlayerPawn(Owner);
	sp = ScriptedPawn(Owner);

	if ((flash != None) && !flash.bDeleteMe)
	{
		flash.LifeSpan = flash.Default.LifeSpan;
	}
	else
	{
		if(sp != None || pp != None)
		{
			if(sp != None)
				GetAxes(sp.Rotation,X,Y,Z);
			else
				GetAxes(pp.ViewRotation,X,Y,Z);

			offset = Owner.Location;
			offset += X * Owner.CollisionRadius * 2;
			flash = spawn(class'MuzzleFlash',,, offset);
			if (flash != None)
				flash.SetBase(Owner);
		}
	}
}

simulated function RefreshScopeDisplay(DeusExPlayer player, bool bInstant, bool bScopeOn)
{
	local DeusExRootWindow root;
	local CrateUnbreakableSmall cus;

	if(Player != None)
	{
		root = DeusExRootWindow(Player.RootWindow);
		if(root.scopeView != None)
		{
			if(root.scopeView.Class == Class'DeusEx.DeusExScopeView')
			{
				root.scopeView.Destroy();
				root.scopeView = None;
				root.scopeView = DeusExScopeView(player.RootWindow.NewChild(Class'FixedDXScopeView', False));
				root.scopeView.SetWindowAlignments(HALIGN_Full, VALIGN_Full, 0, 0);
			}

			if (bScopeOn)
				root.scopeView.ActivateView(ScopeFOV, False, bInstant);
			else
				root.scopeView.DeactivateView();
		}
	}
}

simulated function LockClientFiring(bool bLockOut)
{
	bClientCantFire = bLockOut;
}

simulated function bool GetCliLockState()
{
	return bClientCantFire;
}

simulated function AddRecoilTime()
{
	if(RecoilStrength > 0.0)
	{
		if(RecoilTime > 0.0)
			curRecoilTime += RecoilTime;
		else
			curRecoilTime += ShotTime;
	}
}

simulated function togDownState(bool bNewDown)
{
//	Pawn(Owner).ClientMessage("|P4 - Toggle Down State: switching to:"@bNewDown @ HumanNetmode(Level.Netmode));
	bDownFinished = bNewDown;
//	Pawn(Owner).ClientMessage("|P4 - Toggle Down State: status:"@bDownFinished @ HumanNetmode(Level.Netmode));
}

simulated function togSelectState(bool bNewSelected)
{
//	Pawn(Owner).ClientMessage("|P4 - Toggle Select State: switching to:"@bNewSelected @ HumanNetmode(Level.Netmode));
	bSelectFinished = bNewSelected;
//	Pawn(Owner).ClientMessage("|P4 - Toggle Select State: status:"@bSelectFinished @ HumanNetmode(Level.Netmode));
}

simulated function togReloadState(bool bNewReloaded)
{
//	Pawn(Owner).ClientMessage("|P4 - Toggle Reload State: switching to:"@bNewReloaded @ HumanNetmode(Level.Netmode));
	bReloadFinished = bNewReloaded;
//	Pawn(Owner).ClientMessage("|P4 - Toggle Reload State: status:"@bReloadFinished @ HumanNetmode(Level.Netmode));
}

simulated function SetClientAmmoParams2(float sTime, Sound FireSnd, class<Projectile> pClass, int rCnt, float rTime, int lammow)
{
	bInstantHit = (pClass == None);
	ShotTime = sTime;
	FireSound = FireSnd;
	ProjectileClass = pClass;
	ReloadCount = rCnt;
	ReloadTime = rTime;
	LowAmmoWatermark = lammow;
}

// Sends the sounds of hand to hand weapons impacting to the client creating them.
// ---
// This is only really neccessary due to moving the entire shot pathing system to
// server-side code.
Simulated Function OwnerSwordNoise(Actor Other, vector HitLocation, vector HitNormal)
{
	if(DeusExPlayer(Owner) == None)
		Return;

	if(Other != None)
	{
		// if we are hand to hand, play an appropriate sound
		if (Other.IsA('DeusExDecoration'))
			Owner.PlayOwnedSound(Misc3Sound, SLOT_None,,, 1024);
		else if (Other.IsA('Pawn'))
			Owner.PlayOwnedSound(Misc1Sound, SLOT_None,,, 1024);
		else if (Other.IsA('BreakableGlass'))
			Owner.PlayOwnedSound(sound'GlassHit1', SLOT_None,,, 1024);
		else if (GetWallMaterial(HitLocation, HitNormal) == 'Glass')
			Owner.PlayOwnedSound(sound'BulletProofHit', SLOT_None,,, 1024);
		else
			Owner.PlayOwnedSound(Misc2Sound, SLOT_None,,, 1024);
	}
}

simulated final function bool IsSword()
{
	return (Default.bHandToHand && Default.ReloadCount == 0);
}

simulated final function bool IsThrown()
{
	return (Default.bHandToHand && Default.ReloadCount == 1);
}

simulated final function bool CanPlaceGrenade()
{
	return (HasAnim('PlaceBegin') && HasAnim('Place') && HasAnim('PlaceEnd') && DeusExPlayer(Owner) != None);
}

Simulated Function bool SimNeedReload()
{
	return ((ClipCount >= ReloadCount) && !IsSword() && !IsThrown());
}

Simulated final Function Int SimGetAmmoNum()
{
	local int d;

	if(bHandToHand || AmmoType == None)
		return 0;

	for(d = 0; d < 3; d++)
		if(AmmoType.Class == AmmoNames[d])
			return d;

	return 0;
}

Simulated final function ForceClientReload()
{
	ClipCount = ReloadCount;
	SimEndClipReload();
}

simulated function SimEndClipReload()
{
	local DeusExPlayer dxp;

	dxp = DeusExPlayer(Owner);
	if (SimNeedReload())
	{
		if (Owner != None)
		{
			bFiring = False;
			if (bHasMuzzleFlash)
				EraseMuzzleFlashTexture();
			if (dxp != None)
			{
				bInProcess = False;
				if (dxp.bAutoReload)
				{
					if(AmmoType.AmmoAmount <= 0)
					{
						if(AmmoType.Class != AmmoNames[0])
							bClientReadyToFire = False;
						else
							GotoState('SimQuickFinish');
					}
					else
					{
						bClientReadyToFire = False;
						ReloadAmmo();
						GotoState('SimQuickFinish');
					}
				}
				else
				{
					PlayIdleAnim();
					GotoState('SimQuickFinish');
				}
			}
			else if (Owner.IsA('ScriptedPawn'))
			{
				bFiring = False;
				log("Somehow" @ Owner.Name @ "has attempted to reload as a client. When they're a bot. How odd.", 'BotNotes');
			}
		}
		else
		{
			bInProcess = False;
			GotoState('SimQuickFinish');
		}
	}
}

// calculate the accuracy for this weapon and the owner's damage
simulated function float CalculateAccuracy()
{
	local float accuracy;		// 0 is dead on, 1 is pretty far off
	local float tempacc, div, wSkill;
	local DeusExPlayer player;
	local ScriptedPawn pawn;
	local int HealthArmRight, HealthArmLeft, HealthHead;
	local int BestArmRight, BestArmLeft, BestHead;
	local bool checkit;

	accuracy = BaseAccuracy;	// start with the weapon's base accuracy
	player = DeusExPlayer(Owner);
	pawn = ScriptedPawn(Owner);

	if (player != None)
	{
		wSkill = GetWeaponSkill();
		accuracy += wSkill;
	}

	if ( Level.NetMode == NM_Standalone )
	{
		if (player != None)
		{
			// check the player's skill
			// 0.0 = dead on, 1.0 = way off
			// get the health values for the player
			HealthArmRight = player.HealthArmRight;
			HealthArmLeft  = player.HealthArmLeft;
			HealthHead     = player.HealthHead;
			BestArmRight   = player.Default.HealthArmRight;
			BestArmLeft    = player.Default.HealthArmLeft;
			BestHead       = player.Default.HealthHead;
			checkit = True;
		}
		else if (pawn != None)
		{
			// update the weapon's accuracy with the ScriptedPawn's BaseAccuracy
			// (BaseAccuracy uses higher values for less accuracy, hence we add)
			accuracy += pawn.BaseAccuracy;

			// get the health values for the NPC
			HealthArmRight = pawn.HealthArmRight;
			HealthArmLeft  = pawn.HealthArmLeft;
			HealthHead     = pawn.HealthHead;
			BestArmRight   = pawn.Default.HealthArmRight;
			BestArmLeft    = pawn.Default.HealthArmLeft;
			BestHead       = pawn.Default.HealthHead;
			checkit = True;
		}
		else
			checkit = False;

		if (checkit)
		{
			if (HealthArmRight < 1)
				accuracy += 0.5;
			else if (HealthArmRight < BestArmRight * 0.34)
				accuracy += 0.2;
			else if (HealthArmRight < BestArmRight * 0.67)
				accuracy += 0.1;

			if (HealthArmLeft < 1)
				accuracy += 0.5;
			else if (HealthArmLeft < BestArmLeft * 0.34)
				accuracy += 0.2;
			else if (HealthArmLeft < BestArmLeft * 0.67)
				accuracy += 0.1;

			if (HealthHead < BestHead * 0.67)
				accuracy += 0.1;
		}
	}

	// increase accuracy (decrease value) if we haven't been moving for awhile
	// Also increase accuracy if we're crouching.
	// (seriously, why was that not in the original game? O_0)
	//
	// Also-also, only calculate accuracy when owned. I don't know if that was in;
	// I don't care either. It gives me more chance to write silly comments!
	if (player != None || pawn != None)
	{
		if(player != None)
		{
			div = Max(15.0 + 29.0 * wSkill, 0.0);
			accuracy -= FClamp(standingTimer/div, 0.0, 0.6);
		}

		if(((Player != None && Player.bIsCrouching) || (Pawn != None && Pawn.bCrouching)) && bDuckAccBoost)
			accuracy -= 0.05;

		// If players have laser sights, gain a boost.
		if(LaserActiveCheck())
			Accuracy -= 0.05;
	}

	// make sure we don't go negative
	if (accuracy < 0.0)
		accuracy = 0.0;

	// ...or massively inaccurate, for that matter. 
	else if (accuracy > 1.5)
		accuracy = 1.5;

	// Removes the need to code this into the spread calculation.
	// Also makes it so that the first shot isn't guaranteed perfect accuracy (unless set otherwise)
	// Win-win. :D
	if(accuracy < 0.2 && AreaOfEffect == AOE_Cone)
		accuracy = 0.2;

	 // Adding this here so it actually does something on higher accuracy weapons...
	if (bHasScope && !bZoomed)
	{
		if(accuracy <= 0.00)
			Accuracy = 0.05;
		else
			Accuracy += 0.05;
	}

	if(Level.Netmode != NM_StandAlone)
	{
		if(accuracy < MinWeaponAcc)
			accuracy = MinWeaponAcc;
	}
	return accuracy;
}

Simulated function SimPlayFiringSoundEX()
{
	local float pewVolume, pewRadius;
	local Sound pewpewgun;
	if(Owner != None)
	{
		pewVolume = TransientSoundVolume;
		if(bHasSilencer)
		{
			pewRadius = 1024;
			if(SilencedFire != None)
			{
				pewpewgun = SilencedFire;
			}
			else
			{
				pewpewgun = FireSound;
				pewVolume *= 0.333333;
			}
		}
		else
		{
			if(bSoundToRange)
				pewRadius = MaxRange;
			else
				pewRadius = 2048;

			pewpewgun = FireSound;
		}
		Owner.PlaySound(pewpewgun, SLOT_None, pewVolume,, pewRadius);
	}
}

simulated function Vector ComputeProjectileStart(Vector X, Vector Y, Vector Z)
{
	local Vector Start;
	local Pawn P;

	p = Pawn(Owner);

	// if we are instant-hit, non-projectile, then don't offset our starting point by PlayerViewOffset
	if (bInstantHit)
		Start = p.Location + P.BaseEyeHeight * vect(0,0,1);// - Vector(P.ViewRotation)*(0.9 * P.CollisionRadius);
	else
		Start = p.Location + CalcDrawOffset() + FireOffset.X * X + FireOffset.Y * Y + FireOffset.Z * Z;

	return Start;
}

// Special thanks go to Dr. Dumb Lunatic (DDL) for the firing cone edit for trace-shots
// It's now modified to work with projectiles.
simulated function Projectile ProjectileFire(class<projectile> ProjClass, float ProjSpeed, bool bWarn)
{
	local Vector Start, X, Y, Z, tEnd;
	local DeusExProjectile proj;
	local float mult, smult, spd;
	local float volume, radius;
	local int i, numProj;
	local Pawn aPawn;
	local float wSkill, xMod;
	local DeusExPlayer DXP;
	local ScriptedPawn SP;
	local float offset,upset, fR1[2], fR2[2];
	local vector endtrace;
	local float accuracyMod;
	local rotator initdir;

	SP = ScriptedPawn(Owner);
	DXP = DeusExPlayer(Owner);

	If(SP != None)
		accuracyMod = 0.7; // Give the AI a snowball's chance in hell to hit something.
	else
		accuracyMod = 1.0;

	mult = 1.0;
	if (bHandToHand && (DXP != None))
	{
		sMult = DXP.AugmentationSystem.GetAugLevelValue(class'AugCombat');
		if (smult != -1.000000)
			mult = sMult;

		if(CombatStrSetting == COMSTR_Speed || CombatStrSetting == COMSTR_PowSpeed)
			smult = mult; // Speed multiplier.
	}
	wSkill = GetWeaponSkill();
	mult += (2.0 * abs(wSkill));

	// make noise if we are not silenced
	if (!bHasSilencer && !bHandToHand)
	{
		GetAIVolume(volume, radius);
		Owner.AISendEvent('WeaponFire', EAITYPE_Audio, volume, radius);
		Owner.AISendEvent('LoudNoise', EAITYPE_Audio, volume, radius);
		if (!Owner.IsA('PlayerPawn'))
			Owner.AISendEvent('Distress', EAITYPE_Audio, volume, radius);
	}

	if(SP != None)
		GetAxes(SP.ViewRotation,X,Y,Z);
	else if(DXP != None)
		GetAxes(DXP.ViewRotation,X,Y,Z);

	Start = ComputeProjectileStart(X, Y, Z);

	// Are we shooting our load at more than one point?
	if (AreaOfEffect == AOE_Cone)
	{
		numProj = coneSlugs;
	}
	else
	{
		numProj = 1;
	}

	for (i = 0; i < numProj; i++)
	{
		offset = (frand()-0.5); //side to side bit
		//and now hello pythagoras
		upset = Sqrt(0.25 - offset*offset); //max we can go up or down

		fR1[0] = (3000 * offset) * (currentAccuracy * accuracyMod);
		fR2[0] = (3000 * upset) * (currentAccuracy * accuracyMod);
//		fR1[0] = (4591.4165 * offset) * (currentAccuracy * accuracyMod);
//		fR2[0] = (4591.4165 * upset) * (currentAccuracy * accuracyMod);
		fR1[1] = Rand(fR1[0] + 1) - (fR1[0] * 0.5);
		fR2[1] = Rand(fR2[0] + 1) - (fR2[0] * 0.5);

		if(DXP != None)
			adjustedAim = DXP.viewRotation;
		else if(SP != None)
			adjustedAim = SP.AdjustAim(ProjectileClass.Default.Speed, Start, AimError, True, bWarn);

		adjustedAim.Pitch += fR1[1];
		adjustedAim.Yaw += fR2[1];

		if (( Level.NetMode == NM_Standalone ) || ( DXP != None && DXP.PlayerIsListenClient()) )
		{
			proj = DeusExProjectile(Spawn(ProjClass, Owner,, Start, AdjustedAim));
			if (proj != None)
			{
				proj.Damage *= mult;
				if (bHandToHand && (DXP != None) && (CombatStrSetting == COMSTR_Speed || CombatStrSetting == COMSTR_PowSpeed))
				{
					spd = ProjClass.Default.Speed * smult;
					proj.Velocity = spd * vector(AdjustedAim);
				}
				// send the targetting information to the projectile
				if (bCanTrack && (LockTarget != None) && (LockMode == LOCK_Locked))
				{
					proj.Target = LockTarget;
					proj.bTracking = True;
				}
			}
		}
		else
		{
			if (( Role == ROLE_Authority ))
			{
				// Right, screw listing a string of weapons that this applies to, we're simply going to just check if
				// the class has ammo or is a self-contained weapon. Which is what it should've done in the first place. _

				// Scratch even that, we're just going to fire EVERY projectile like this.
				// At least this way it patches the rotation correctly :\
				proj = DeusExProjectile(Spawn(ProjClass, Owner,, Start, AdjustedAim));
				if (proj != None)
				{
					proj.Damage *= mult;
					if (bHandToHand && (DXP != None) && (CombatStrSetting == COMSTR_Speed || CombatStrSetting == COMSTR_PowSpeed))
					{
						spd = ProjClass.Default.Speed * smult;
						proj.Velocity = spd * vector(AdjustedAim);
					}

					// send the targetting information to the projectile					
					if (bCanTrack && (LockTarget != None) && (LockMode == LOCK_Locked))
					{
						proj.Target = LockTarget;
						proj.bTracking = True;
					}
				}
			}
		}
	}
	if(bUseAccuracyPenalty && DXP != None)
	{
		xMod = 2 / (DXP.SkillSystem.GetSkillLevel(GoverningSkill)+1);
		if(xMod == 0.5)
			xMod = 0.25;

		standingtimer -= ((15 - (29 * (wSkill))) * 0.6) * 0.1 * ShotPenaltyMult * xMod;
		if(StandingTimer < 0)
			StandingTimer = 0.000000;
	}
	return proj;
}

// Special thanks go to Dr. Dumb Lunatic (DDL) for the firing edit allowing
// the bullets to fire in a cone instead of a pyramid.
// ---
// LOL FAIL, DX Crew. _
simulated function TraceFire( float Accuracy )
{
	local vector HitLocation, HitNormal, StartTrace, EndTrace, X, Y, Z;
	local Rotator rot;
	local actor Other;
	local float dist, alpha, degrade;
	local int i, numSlugs;
	local float volume, radius;
	local float offset, upset;
	local Tracer tr;
	local float wSkill, xMod, accuracyMod;
	local float oldAccuracy;
	local DeusExPlayer DXP;
	local ScriptedPawn SP;
	local Pawn Pa;

	SP = ScriptedPawn(Owner);
	DXP = DeusExPlayer(Owner);
	Pa = Pawn(Owner);

	// make noise if we are not silenced
	if (!bHasSilencer && !bHandToHand)
	{
		GetAIVolume(volume, radius);
		Owner.AISendEvent('WeaponFire', EAITYPE_Audio, volume, radius);
		Owner.AISendEvent('LoudNoise', EAITYPE_Audio, volume, radius);
		if (DXP == None)
			Owner.AISendEvent('Distress', EAITYPE_Audio, volume, radius);
	}

	GetAxes(Pa.ViewRotation,X,Y,Z);
		
	StartTrace = ComputeProjectileStart(X, Y, Z);
	if(SP != None)
	{
		accuracyMod = 0.564;
		SP.AdjustAim(1000000, StartTrace, 0.0, False, False);
	}
	else if(DXP != None)
	{
		accuracyMod = 1.128;
		AdjustedAim = DXP.ViewRotation;
	}

	// check to see if we are a shotgun-type weapon
	if (AreaOfEffect == AOE_Cone)
	{
		numSlugs = coneSlugs;
		accuracyMod *= 1.5;
	}
	else
	{
		numSlugs = 1;
	}

	// If the scope is on, zero the accuracy so the shake makes the shot inaccurate
	// as opposed to the tracing.
	if (bZoomed)
		Accuracy = 0.0;

	for (i=0; i<numSlugs; i++)
	{
		if(Role == ROLE_Authority)
		{
			if(bOldConeSpread && Level.Netmode != NM_Standalone && !bHandToHand && AreaOfEffect == AOE_Cone)
			{
				if (i == 0)
				{
					oldAccuracy = Accuracy;
					Accuracy = 0.000000;
				}
				else
				{
					Accuracy = oldAccuracy;
				}
			}			

			// Let handtohand weapons have a better swing
			if ((bHandToHand) && (NumSlugs > 1) && (Level.NetMode != NM_Standalone))
			{
				StartTrace = ComputeProjectileStart(X,Y,Z);
				StartTrace = StartTrace + (numSlugs/2 - i) * SwingOffset;
			}

			offset = (frand()-0.5); //side to side bit
			//and now hello pythagoras
			upset = Sqrt(0.25 - offset*offset); //max we can go up or down
			upset *= 2;
			EndTrace = StartTrace + (Accuracy * AccuracyMod * offset * Y * MaxRange * 0.35) + (Accuracy * AccuracyMod * upset * (FRand()-0.5) * Z * MaxRange * 0.35);
			EndTrace += MaxRange * X;

			Other = Pa.TraceShot(HitLocation,HitNormal,EndTrace,StartTrace);

			// Draw tracers all the time, even if zoomed.
			if (bInstantHit && !bHandToHand) // if we're a gun...
			{
				if (VSize(HitLocation - StartTrace) > 250)
				{
					rot = Rotator(EndTrace - StartTrace);
					tr = Spawn(class'Tracer',DXP,, StartTrace + 96 * Vector(rot), rot);
				}
			}

			// check our range
			dist = Abs(VSize(HitLocation - Owner.Location));

			if (dist <= AccurateRange)		// we hit just fine
				ProcessTraceHit(Other, hitlocation, HitNormal, vector(AdjustedAim),Y,Z);
			else if (dist <= MaxRange)
			{
				Pa.ClientMessage("Pre-gravity HitLocation:" @ HitLocation);
				// simulate gravity by lowering the bullet's hit point
				// based on the owner's distance from the ground
				alpha = (dist - AccurateRange) / (MaxRange - AccurateRange);
				degrade = 0.5 * Square(alpha);
				hitlocation.Z += degrade * (Owner.Location.Z - Owner.CollisionHeight);
				Pa.ClientMessage("Post-gravity HitLocation:" @ HitLocation);
				ProcessTraceHit(Other, hitlocation, HitNormal, vector(AdjustedAim),Y,Z);
			}
			if(DXP != None && Level.Netmode != NM_Standalone)
			{
				if(!IsSword())
					DXP.ClientSpawnHits( bPenetrating, bHandToHand, HitLocation, HitNormal, Other, HitDamage );
				else
					OwnerSwordNoise(Other, HitLocation, HitNormal);
			}
		}
	}
	if(bUseAccuracyPenalty)
	{
		wSkill = GetWeaponSkill();

		if(DXP != None)
		{
			xMod = 2 / (DXP.SkillSystem.GetSkillLevel(GoverningSkill)+1);
			if(xMod == 0.5)
				xMod = 0.25;
		}
		else
			xMod = 1;

		standingtimer -= ((15 - (29 * (wSkill))) * 0.6) * 0.1 * ShotPenaltyMult * xMod;
		if(StandingTimer < 0)
			StandingTimer = 0.000000;
	}
}

simulated function bool ClientFire(float value)
{
	local bool bWaitOnAnim;
	local vector shake;
	local DeusExPlayer pOwner;

	pOwner = DeusExPlayer(Owner);

	// check for surrounding environment
	if ((EnviroEffective == ENVEFF_Air) || (EnviroEffective == ENVEFF_Vacuum) || (EnviroEffective == ENVEFF_AirVacuum))
	{
		if (Region.Zone.bWaterZone)
		{
			if (pOwner != None)
			{
				pOwner.ClientMessage(msgNotWorking);
				if (!bHandToHand)
					PlaySimSound( Misc1Sound, SLOT_None, TransientSoundVolume * 2.0, 1024 );
			}
			return false;
		}
	}

	if((Default.ReloadCount == 1 || (mpReloadCount == 1 && Default.ReloadCount != 1) || Default.AmmoReload[SimGetAmmoNum()] == 1) && ReloadCount != 1)
	{
		if(pOwner != None)
		{
			BroadcastMessage("|P2Hey, everyone!" @ pOwner.PlayerReplicationInfo.PlayerName @ "|P2is cheating! |P3(Non-standard ReloadCount variable)");
			//add some kick code here, maybe?
		}

		ReloadCount = 1;
	}

	if(!bLooping)
	{
		bWaitOnAnim =	(IsAnimating() &&
						(AnimSequence == 'Select')	|| (AnimSequence == 'Shoot')		|| (AnimSequence == 'ReloadBegin')
					||	(AnimSequence == 'Reload')	|| (AnimSequence == 'ReloadEnd')	|| (AnimSequence == 'Down')
					||	(AnimSequence == 'Place'));
	}
	else
	{
		bWaitOnAnim = false;
		bLooping = false;
	}

	if(pOwner != None)
	{
		if (pOwner.NintendoImmunityTimeLeft > 0.01 || (!bClientReadyToFire || bInProcess || bWaitOnAnim ))
		{
			pOwner.bJustFired = False;
			bPointing = False;
			bFiring = False;
			return false;
		}
	}

	ServerForceFire();

	if (bHandToHand)
	{
		if(Default.ReloadCount > 0)
			SimAmmoAmount = AmmoType.AmmoAmount - 1;

		bClientReadyToFire = False;
		bInProcess = True;
		GotoState('ClientFiring');
		bPointing = True;
		if ( pOwner != None )
			pOwner.PlayFiring();
		PlaySelectiveFiring();
	}
	else if ((ClipCount < ReloadCount) || (Default.ReloadCount == 0))
	{
		if ((Default.ReloadCount == 0) || (AmmoType.AmmoAmount > 0))
		{
			bFiring = True;
			bPointing = True;
			bClientReadyToFire = False;
			bInProcess = True;

			GotoState('ClientFiring');

			if(Value == 0.000000)
			{
				SimClipCount = ClipCount + 1;
				AmmoType.SimUseAmmo();
				if ((bInstantHit) || (ProjectileNames[SimGetAmmoNum()] == None && Default.ProjectileClass == None))
					TraceFire(currentAccuracy);
				else
					ProjectileFire(ProjectileClass, ProjectileSpeed, bWarnTarget);
			}

			if ( pOwner != None && bShakeViewOn )
			{
				shake.X = 0.0;
				shake.Y = 100.0 * (ShakeTime*0.5);
				shake.Z = 100.0 * -(currentAccuracy * ShakeVert);
				pOwner.ClientShake( shake );
			}
			pOwner.PlayFiring();
			PlaySelectiveFiring();
		}
		else
		{
			if(AmmoType.AmmoAmount > 0)
				SimEndClipReload();
			PlaySimSound( Misc1Sound, SLOT_None, TransientSoundVolume * 2.0, 1024 );		// play dry fire sound
		}
	}
	else
	{
		if(AmmoType.AmmoAmount > 0)
			SimEndClipReload();
		PlaySimSound( Misc1Sound, SLOT_None, TransientSoundVolume * 2.0, 1024 );		// play dry fire sound
	}
	return true;
}

simulated function ProcessTraceHit(Actor Other, Vector HitLocation, Vector HitNormal, Vector X, Vector Y, Vector Z)
{
	local float			mult;
	local name			damageType;
	local DeusExPlayer	dxPlayer, dxTarg;
	local ScriptedPawn	pTarg;
	local Pawn			pOwner;
	local vector		offsetXYZ;
	local int			hitPoint;
	local Sound			hitConfirmSFX;

	if (Other != None)
	{
		pOwner = Pawn(Owner);
		dxPlayer = DeusExPlayer(Owner);

		// AugCombat increases our damage if hand to hand
		mult = 1.0;
		if (bHandToHand && (dxPlayer != None) && (CombatStrSetting == COMSTR_Classic || CombatStrSetting == COMSTR_PowSpeed))
		{
			mult = dxPlayer.AugmentationSystem.GetAugLevelValue(class'AugCombat');
			if (mult == -1.0)
				mult = 1.0;
		}

		// skill also affects our damage
		// GetWeaponSkill returns 0.0 to -0.7 (max skill/aug)
		mult += 2.0 * abs(GetWeaponSkill());

		// Determine damage type
		damageType = WeaponDamageType();

		if (Other != None)
		{
			if (Other.bOwned)
			{
				if (dxPlayer != None)
					dxPlayer.AISendEvent('Futz', EAITYPE_Visual);
			}
		}
		if ((Other == Level) || (Other.IsA('Mover')))
		{
			if ( Role == ROLE_Authority )
				Other.TakeDamage(HitDamage * mult, pOwner, HitLocation, 1000.0*X, damageType);

			SelectiveSpawnEffects( HitLocation, HitNormal, Other, HitDamage * mult);
		}
		else if ((Other != self) && (Other != Owner))
		{
			if ( Role == ROLE_Authority )
				Other.TakeDamage(HitDamage * mult, pOwner, HitLocation, 1000.0*X, damageType);
			if (bHandToHand)
				SelectiveSpawnEffects( HitLocation, HitNormal, Other, HitDamage * mult);
			if (bPenetrating && Other.IsA('Pawn') && !Other.IsA('Robot'))
				SpawnBlood(HitLocation, HitNormal);
			if (Other.IsA('Pawn') && bMLGDORITOS)
				UpdateHitMarker(Other, HitLocation);
		}
	}
}

simulated function UpdateHitMarker(Actor Other, vector HitLocation)
{/*
	local DeusExPlayer	dxPlayer, dxTarg;
	local ScriptedPawn	pTarg;
	local vector		offsetXYZ;
	local Sound			hitConfirmSFX;

	dxPlayer = DeusExPlayer(Owner);
	dxTarg = DeusExPlayer(Other);
	pTarg = ScriptedPawn(Other);

	if(dxPlayer == None)
		return;

	if(Role != ROLE_Authority)
		return;

	if(dxTarg != None)
	{
		bHeadshotMarker = (dxTarg.GetMPHitLocation(HitLocation) == 1);
	}
	else if(pTarg != None)
	{
		if(!pTarg.IsA('Robot') && !pTarg.IsA('Animal'))
		{
			offsetXYZ = (hitLocation - pTarg.Location) << pTarg.Rotation;
			bHeadshotMarker = NPCHeadshotCheck(offsetXYZ, pTarg, False);
		}
		else
		{
			bHeadshotMarker = False; // Can't headshot that without a head!
		}
	}

	HMTex = Texture(DynamicLoadObject(HitM_Texture, class'Texture'));
	FadeOutSeconds = 0.2;

	if((bHeadshotMarker && !bHSS) || !bSS)
	{
		if(bHeadshotMarker)
			HitConfirmSFX = Sound(DynamicLoadObject(HitM_Head, class'Sound'));
		else
			HitConfirmSFX = Sound(DynamicLoadObject(HitM_Normal, class'Sound'));
		dxPlayer.ClientPlaySound(HitConfirmSFX);
	}*/

	//bHSS = bHeadshotMarker;
	//bSS = True;
}

function bool NPCHeadshotCheck(vector Offset, ScriptedPawn victim, optional bool bSidesAreHead)
{
	local float        headOffsetZ, headOffsetY;

	headOffsetZ = victim.CollisionHeight * 0.7;
	headOffsetY = victim.CollisionRadius * 0.3;

	if (offset.z > headOffsetZ)		// head
	{
		// narrow the head region
		if ((Abs(offset.x) < headOffsetY) || (Abs(offset.y) < headOffsetY))
		{
			return True;
		}
		else  // sides of head treated as torso
		{
			return bSidesAreHead;
		}
	}

	return False;
}

simulated function bool NearWallCheck()
{
	local Vector StartTrace, EndTrace, HitLocation, HitNormal;
	local Actor HitActor;
	local DeusExPlayer DXP;

	// Scripted pawns can't place LAMs
	DXP = DeusExPlayer(Owner);

	if (DXP == None)
		return False;

	// Don't let players place grenades when they have something highlighted
	if ( Level.NetMode != NM_Standalone )
	{
		if ( DXP.frobTarget != None )
		{
			if ( DXP.IsFrobbable( DXP.frobTarget ) )
				return False;
		}
	}

	// trace out one foot in front of the pawn
	// (32 is two feet, dummies.)
	StartTrace = Owner.Location;
	EndTrace = StartTrace + Vector(DXP.ViewRotation) * 32;

	StartTrace.Z += DXP.BaseEyeHeight;
	EndTrace.Z += DXP.BaseEyeHeight;

	HitActor = Trace(HitLocation, HitNormal, EndTrace, StartTrace);
	if ((HitActor == Level) || ((HitActor != None) && HitActor.IsA('Mover')))
	{
		placeLocation = HitLocation;
		placeNormal = HitNormal;
		placeMover = Mover(HitActor);
		return True;
	}

	return False;
}

simulated function Tick(float deltaTime)
{
	local rotator 		rot;
	local float			recoil, beepspeed, wSkill, timedif, mWSkill;
	local DeusExPlayer	player, targDXP;
	local Pawn			pawn, targP;
	local Actor			realtarget;
	local name			Stat3d;
	local DeusExAmmo	ownerAmmo;

	player = DeusExPlayer(Owner);
	pawn = Pawn(Owner);
	Stat3d = GetStateName();

	if(pawn == None && player == None)
	{
		if(bHasLaser && lSpot != None)
			LaserOff();

		Return;
	}

	If(bMLGDORITOS && Player != None)
	{
		if(FadeOutSeconds > 0.0)
			FadeOutSeconds -= Deltatime;
		bSS = False;
		bHSS = False;
	}

	if ((Player != None || Pawn != None))
	{
		//Why waste CPU cycles on calculating accuracy of melee when it's auto-zeroed?
		if(((Player != None && (player.Weapon == Self || bOldAccuDecay)) || (Pawn != None && Pawn.Weapon == Self)) && !IsSword()) 
		{
			currentAccuracy = CalculateAccuracy();
		}
		else
		{
			currentAccuracy = 0.000000;
		}

		if(Player != None)
		{
			wSkill = GetWeaponSkill();
		}

		if(Player != None && OnlyToOwner())
		{
			if(player.Weapon == Self || bOldAccuDecay)
			{
				if (VSize(Player.Velocity) < 25)
				{
					if(bOldAccuDecay || (Stat3d == 'Idle' || Stat3d == 'SimIdle' || Stat3d == 'NormalFire' || Stat3d == 'ClientFiring'))
					{
						mWSkill = abs(wSkill); // For sake of not breaking, we cap standing time calculations at Master Level.
						if(mWSkill > 0.5)
							mWSkill = 0.5;

						if(standingtimer < (15 - (29 * (mWSkill))) * 0.6 * (BaseAccuracy / 0.6))
							standingTimer += deltaTime;
						else
							standingtimer = (15 - (29 * (mWSkill))) * 0.6 * (BaseAccuracy / 0.6);
					}
				}
				else
				{
					standingTimer = FMax(0, standingTimer - (0.04 / (player.SkillSystem.GetSkillLevel(GoverningSkill)+1))*deltaTime*VSize(Owner.Velocity));
				}
			}
			else
			{
				standingTimer = 0.0;
			}
		}
	}

	if(player != None && player.Weapon == Self)
	{
		if (bCanTrack && Default.bCanTrack)
		{
			if(ClipCount < ReloadCount)
			{
				if (  (Level.Netmode == NM_Standalone) || ( (Player != None) && (Player.PlayerIsClient()) ) )
				{
					if(IsInState('Idle') || IsInState('SimIdle'))
					{
						Target = AcquireTarget();
						RealTarget = Target;

						// calculate the range
						if (Target != None)
							TargetRange = Abs(VSize(Target.Location - Location));

						targP = Pawn(Target);
						targDXP = DeusExPlayer(Target);

						if(LockMode == LOCK_Acquire)
						{
							if(Target != None)
							{
								If(ACQTarget == None && targP != None)
									ACQTarget = Target;
								else if(ACQTarget != None && targP != None && Target != ACQTarget)
								{
									ACQTarget = Target;
									StartLockTime = 0.000000;
									LockBrokeTime = 0.000000;
								}
							}
						}
						// check target and range info to see what our mode is
						if (Target == None)
						{
							if ((LockBrokeTime <= Level.TimeSeconds))
							{
								SetLockMode(LOCK_None);
							}
							else if (LockMode == LOCK_Locked)
							{
								Target = LockTarget;
							}
						}
						else if ((Target != LockTarget) && TargP != None && (LockMode == LOCK_Locked))
						{
							SetLockMode(LOCK_None);
						}
						else if (targP == None)
						{
							if (LockBrokeTime <= Level.TimeSeconds)
							{
								SetLockMode(LOCK_Invalid);
							}
						}
						else if ( TargDXP != None && (Target.Style == STY_Translucent) )
						{
							//DEUS_EX AMSD Don't allow locks on cloaked targets.
							SetLockMode(LOCK_None);
						}
						else if ( (TargDXP != None) && (Player.DXGame.IsA('TeamDMGame')) && (TeamDMGame(Player.DXGame).ArePlayersAllied(Player,TargDXP)) )
						{
							//DEUS_EX AMSD Don't allow locks on allies.
							SetLockMode(LOCK_Invalid);
						}
						else
						{
							if (TargetRange > MaxRange)
							{
								SetLockMode(LOCK_Range);
							}
							else
							{
								// change LockTime based on skill
								// -0.7 = max skill
								// DEUS_EX AMSD Only do weaponskill check here when first checking.
								if (StartLockTime == 0.000000)
								{
									LockTime = FMax(Default.LockTime + 3.0 * wSkill, 0.0);
									if ((Level.Netmode != NM_Standalone) && (LockTime < 0.25))
										LockTime = 0.25;

									StartLockTime = Level.TimeSeconds + LockTime;
								}

								if (StartLockTime <= Level.TimeSeconds)
									SetLockMode(LOCK_Locked);
								else
									SetLockMode(LOCK_Acquire);
							}
						}

						// act on the lock mode
						switch (LockMode)
						{
							case LOCK_None:
								TargetMessage = msgNone;
								ACQTarget = None;
								LockBrokeTime = 0.000000;
								StartLockTime = 0.000000;
								LockTarget = None;
								break;

							case LOCK_Invalid:
								TargetMessage = msgLockInvalid;
								ACQTarget = None;
								LockBrokeTime = 0.000000;
								StartLockTime = 0.000000;
								LockTarget = None;
								break;

							case LOCK_Range:
								TargetMessage = msgLockRange @ Int(TargetRange/16) @ msgRangeUnit;
								ACQTarget = None;
								LockBrokeTime = 0.000000;
								StartLockTime = 0.000000;
								LockTarget = None;
								break;

							case LOCK_Acquire:
								TargetMessage = msgLockAcquire @ Left(String(StartLockTime - Level.TimeSeconds), 4) @ msgTimeUnit;
								beepspeed = FClamp((StartLockTime - Level.TimeSeconds) / Default.LockTime, 0.2, 1.0);
								if (LastTRKBeep < Level.TimeSeconds)
								{
									Owner.PlaySound(TrackingSound, SLOT_None);
									LastTRKBeep = Level.TimeSeconds + beepspeed;
								}
								break;

							case LOCK_Locked:
								// If maintaining a lock, or getting a new one, increment maintainlocktimer
								if ((RealTarget != None) && ((RealTarget == LockTarget) || (LockTarget == None)))
								{
									if(Level.Netmode != NM_Standalone)
										LockBrokeTime = Level.TimeSeconds + Default.MaintainLockTimer;
									else
										LockBrokeTime = Level.TimeSeconds + 0.25;
									LockTarget = Target;
								}

								if (LockTarget != None)
								{
									TargetRange = Abs(VSize(LockTarget.Location - Location));
									TargetMessage = msgLockLocked @ Int(TargetRange/16) @ msgRangeUnit;
								}
								else
								{
									TargetMessage = "---";
								}
								break;
						}
					}
					else
					{
						SetLockMode(LOCK_None);
						LockTarget = None;
						LockBrokeTime = 0.000000;
						StartLockTime = 0.000000;
						ACQTarget = None;
						TargetMessage = "---";
					}
				}

				if ((LockMode == LOCK_Locked) && (Level.TimeSeconds > LastLCKBeep + 0.1) && (Role == ROLE_Authority))
				{
					PlayLockSound();
					LastLCKBeep = Level.TimeSeconds;
				}
			}
			else if ((Level.Netmode == NM_Standalone) || ((Player != None) && (Player.PlayerIsClient())))
			{
				SetLockMode(LOCK_None);
				LockTarget = None;
				LockBrokeTime = 0.000000;
				StartLockTime = 0.000000;
				ACQTarget = None;
				TargetMessage = "---";
			}
		}

		// May also prevent lam-bugging?
		if(OnlyToOwner())
		{
			if(CanPlaceGrenade() && ProjectileClass != None && bHandToHand)
			{
				if (AmmoType.AmmoAmount > 0 && (stat3D == 'Idle' || stat3D == 'NormalFire' || stat3d == 'SimIdle' || stat3d == 'ClientFiring'))
				{
					// check for LAM or other placed mine placement
					if (NearWallCheck())
					{
						if (IsAnimating() && (AnimSequence == 'Select' || AnimSequence == 'Down'))
						{
							// Do absolutely nothing.
						}
						else
						{
							if (!bNearWall)
							{
								PlayAnim('PlaceBegin',, 0.1);
								bNearWall = True;
							}
						}
					}
					else
					{
						if (bNearWall)
						{
							PlayAnim('PlaceEnd',, 0.1);
							bNearWall = False;
						}
					}
				}
			}
		}

		if (bZoomed)
		{
			// shake our view to simulate poor aiming
			if (ShakeTimer > 0.2)
			{
				ShakeYaw = currentAccuracy * (Rand(4097) - 2048);
				ShakePitch = currentAccuracy * (Rand(4097) - 2048);
				ShakeTimer -= 0.2;
			}

			ShakeTimer += deltaTime;
			player.ViewRotation.Yaw += deltaTime * ShakeYaw;
			player.ViewRotation.Pitch += deltaTime * ShakePitch;
		}

		if (Level.Netmode == NM_Standalone || IsServer())
		{
			if(!bHasLaser && bCanHaveLaser && bAutoLaser)
				bHasLaser = True;

			if (bHasLaser)
			{
				Stat3d = GetStateName();
				Switch(Stat3d)
				{
					Case 'SimIdle':
					Case 'Idle':
					Case 'ClientFiring':
					Case 'NormalFire':
					Case 'Reload':
					Case 'SimReload':
						if(LaserActiveCheck()) 
						UpdateSpot();
						Break;

					Default:
						LaserOff();
				}
			}
		}

		if(Role < ROLE_Authority && recoilStrength > 0.0)
		{
			Switch(RecoilSetting)
			{
				case RECOIL_Full:			// DXSM scaling Recoil Reduction
					recoil = recoilStrength / (abs(wSkill) * 4.0 + 1); 
					Break;
				case RECOIL_Classic:		// DX Vanilla flat Recoil reduction
					recoil = recoilStrength + wSkill * 2.0;
					Break;
				case RECOIL_ZeroAtMaster:	// DXSM scaling, but zeroes at Master level
					if(wSkill <= -0.5)
						recoil = 0.000000;
					else
						recoil = recoilStrength / (abs(wSkill) * 4.0 + 1); // Scaling recoil reduction

					Break;
			}

			if (recoil < 0.0)
				recoil = 0.0;

			// simulate recoil while firing
			if (IsAnimating() && AnimSequence == 'Shoot' && recoil > 0.0 && curRecoilTime > 0.0)
			{
				player.ViewRotation.Pitch += deltaTime * (Rand(4096) + 4096) * recoil;
				if ((player.ViewRotation.Pitch > 16384) && (player.ViewRotation.Pitch < 32768))
					player.ViewRotation.Pitch = 16384;

				if(curRecoilTime > 0.000000)
				{
					curRecoilTime -= Deltatime;
					if(curRecoilTime < 0.000000)
						curRecoilTime = 0.000000;
				}
			}
		}
	}
}

simulated function SelectiveSpawnEffects( Vector HitLocation, Vector HitNormal, Actor Other, float Damage)
{
	local DeusExPlayer fxOwner,notfxO;
	local Pawn aPawn;

	// The normal path before there was multiplayer
	if ( Level.NetMode == NM_Standalone )
	{
		SpawnEffects(HitLocation, HitNormal, Other, Damage);
		return;
	}

	fxOwner = DeusExPlayer(Owner);

	if ( Role == ROLE_Authority )
	{
		SpawnEffectSounds(HitLocation, HitNormal, Other, Damage );

		for ( aPawn = Level.PawnList; aPawn != None; aPawn = aPawn.nextPawn )
		{
			notfxO = DeusExPlayer(aPawn);
			if(notfxO != None)
			{
				if(fxOwner == None || fxOwner != notfxO)
				{
					if ( notfxO.FastTrace( notfxO.Location, HitLocation ))
						notfxO.ClientSpawnHits( bPenetrating, bHandToHand, HitLocation, HitNormal, Other, Damage );
				}
			}
		}
	}
	if ( (fxOwner != None) && fxOwner == DeusExPlayer(GetPlayerPawn()) )
	{
		fxOwner.ClientSpawnHits( bPenetrating, bHandToHand, HitLocation, HitNormal, Other, Damage );
		SpawnEffectSounds( HitLocation, HitNormal, Other, Damage );
	}
}

simulated function SimFinish()
{
	local Pawn pOwner;
	local DeusExPlayer dxpOwner;

	dxpOwner = DeusExPlayer(Owner);
	ServerGotoFinishFire();

	bInProcess = False;
	bFiring = False;

	if (bHasMuzzleFlash)
		EraseMuzzleFlashTexture();

	if ( dxpOwner != None && dxpOwner.bAutoReload )
	{
		if ((AmmoType.AmmoAmount == 0) && (AmmoType.Class != AmmoNames[0]) && !bHandToHand)
			LoadAmmo(0);
		if ( (SimClipCount >= ReloadCount) && CanReload() )
		{
			SimClipCount = 0;
			bClientReadyToFire = False;
			bInProcess = False;
			ReloadAmmo();
		}
	}

	if (Owner == None)
	{
		GotoState('SimIdle');
		return;
	}

	pOwner = Pawn(Owner);

	if ( pOwner != None )
	{
		if ( pOwner.bFire != 0 && (AmmoType.AmmoAmount > 0 || IsSword()))
			ClientReFire(0);
		else
			GotoState('SimIdle');
	}
}

 // Modded so only players can track.
simulated function Actor AcquireTarget()
{
	local vector StartTrace, EndTrace, HitLocation, HitNormal;
	local Actor hit, retval;
	local DeusExPlayer p;

	p = DeusExPlayer(Owner);
	if (p == None)
		return None;

	StartTrace = p.Location;
	EndTrace = p.Location + (MaxRange * Vector(p.ViewRotation));

	// adjust for eye height
	StartTrace.Z += p.BaseEyeHeight;
	EndTrace.Z += p.BaseEyeHeight;

	foreach TraceActors(class'Actor', hit, HitLocation, HitNormal, EndTrace, StartTrace)
		if (!hit.bHidden && (hit.IsA('Decoration') || hit.IsA('Pawn')))
			return hit;

	return None;
}

simulated function SawedOffCockSound()
{
	Owner.PlaySound(SelectSound, SLOT_None,,, 1024);
}

simulated function ClientReFire( float value )
{
	bClientReadyToFire = True;
	bLooping = True;
	bInProcess = False;
	ClientFire(0.1);
}

simulated function PlaySelectiveFiring()
{
	local Pawn aPawn;
	local float rnd;
	local Name anim;
	local float mult;
	local DeusExPlayer dxp, dxp2;

	anim = 'Shoot';
	mult = 1.0;

	dxp = DeusExPlayer(Owner);

	if (bHandToHand)
	{
		if(CanPlaceGrenade() && bNearWall)
		{
			anim = 'Place';
		}
		else
		{
			rnd = FRand();
			if (rnd < 0.33)
				anim = 'Attack';
			else if (rnd < 0.66)
				anim = 'Attack2';
			else
				anim = 'Attack3';
		}

		// AugCombat decreases shot time (Except for placing grenades)
		if ((CombatStrSetting == COMSTR_Speed || CombatStrSetting == COMSTR_PowSpeed) && anim != 'Place' && dxp != None)
		{
			mult = dxp.AugmentationSystem.GetAugLevelValue(class'AugCombat');
			if (mult == -1.0)
				mult = 1.0;
		}
	}

	if (( Level.NetMode == NM_Standalone ) || ( dxp == DeusExPlayer(GetPlayerPawn())) )
	{
		PlayAnim(anim,mult,0.1);
	}
	else if ( Role == ROLE_Authority )
	{
		for ( aPawn = Level.PawnList; aPawn != None; aPawn = aPawn.nextPawn )
		{
			dxp2 = DeusExPlayer(aPawn);
			if ( dxp2 != None && ( dxp != dxp2 ) )
			{
				// If they can't see the weapon, don't bother
				if ( dxp2.FastTrace( dxp2.Location, Location ))
					dxp2.ClientPlayAnimation( Self, anim, 0.1, False );
			}
		}
	}
}

simulated function ResetHDTP()
{
	if(bUseHDTP && bCheckedHDTP)
	{
		bCheckedHDTP = False;
	}
}

/*----------------------------\\
|| Standard Functions         ||
\\----------------------------*/

function bool OnlyToOwner()
{
	if(Role == ROLE_Authority || (Role < ROLE_Authority && bNetOwner))
		return true;

	return False;
}

// 0 = Select, 1 = Down, 2 = ReloadBegin, 3 = ReloadEnd
function float GetAnimationSleepTime(int actionType)
{
	local float animFrame, animRate;
	if(actionType >= 0 && actionType <= 3)
	{
		animFrame = animFrames[actionType];
		animRate = animRates[actionType];
		// Apparently we can't do maths with array variables directly. Go figure.

		If(PlayerViewMesh == LodMesh'DeusExItems.GEPGun')
		{
			if(actionType == 0) return 1.000000;
			if(actionType == 1) return 1.000000;
			if(actionType == 2) return 1.250000;
			if(actionType == 3) return 0.800000;
		}
		else if(PlayerViewMesh == LodMesh'DeusExItems.Glock')
		{
			if(actionType == 0) return 0.625000;
			if(actionType == 1) return 0.125000;
			if(actionType == 2) return 0.666666;
			if(actionType == 3) return 0.375000;
		}
		else if(PlayerViewMesh == LodMesh'DeusExItems.SniperRifle')
		{
			if(actionType == 0) return 0.416666;
			if(actionType == 1) return 0.250000;
			if(actionType == 2) return 1.000000;
			if(actionType == 3) return 0.500000;
		}
		else if(PlayerViewMesh == LodMesh'DeusExItems.CombatKnife')
		{
			if(actionType == 0) return 0.428571;
			if(actionType == 1) return 0.500000;
			if(actionType == 2) return -1.000000;
			if(actionType == 3) return -1.000000;
		}
		else if(PlayerViewMesh == LodMesh'DeusExItems.Crowbar')
		{
			if(actionType == 0) return 0.333333;
			if(actionType == 1) return 0.300000;
			if(actionType == 2) return -1.000000;
			if(actionType == 3) return -1.000000;
		}
		else if(PlayerViewMesh == LodMesh'DeusExItems.StealthPistol')
		{
			if(actionType == 0) return 0.500000;
			if(actionType == 1) return 0.416666;
			if(actionType == 2) return 0.875000;
			if(actionType == 3) return 0.166666;
		}
		else if(PlayerViewMesh == LodMesh'DeusExItems.Prod')
		{
			if(actionType == 0) return 1.000000;
			if(actionType == 1) return 0.400000;
			if(actionType == 2) return 0.600000;
			if(actionType == 3) return 0.600000;
		}
		else if(PlayerViewMesh == LodMesh'DeusExItems.HideAGun')
		{
			if(actionType == 0) return 0.600000;
			if(actionType == 1) return 0.250000;
			if(actionType == 2) return -1.000000;
			if(actionType == 3) return -1.000000;
		}
		else if(PlayerViewMesh == LodMesh'DeusExItems.AssaultGun')
		{
			if(actionType == 0) return 0.444444;
			if(actionType == 1) return 0.500000;
			if(actionType == 2) return 0.500000;
			if(actionType == 3) return 0.300000;
		}
		else if(PlayerViewMesh == LodMesh'DeusExItems.LAW')
		{
			if(actionType == 0) return 1.428571;
			if(actionType == 1) return 1.250000;
			if(actionType == 2) return -1.000000;
			if(actionType == 3) return -1.000000;
		}
		else if(PlayerViewMesh == LodMesh'DeusExItems.LAM')
		{
			if(actionType == 0) return 1.200000;
			if(actionType == 1) return 0.833333;
			if(actionType == 2) return -1.000000;
			if(actionType == 3) return -1.000000;
		}
		else if(PlayerViewMesh == LodMesh'DeusExItems.PepperGun')
		{
			if(actionType == 0) return 0.545454;
			if(actionType == 1) return 0.400000;
			if(actionType == 2) return 0.333333;
			if(actionType == 3) return 0.250000;
		}
		else if(PlayerViewMesh == LodMesh'DeusExItems.Flamethrower')
		{
			if(actionType == 0) return 0.666666;
			if(actionType == 1) return 0.500000;
			if(actionType == 2) return 0.375000;
			if(actionType == 3) return 0.444444;
		}
		else if(PlayerViewMesh == LodMesh'DeusExItems.MiniCrossbow')
		{
			if(actionType == 0) return 1.200000;
			if(actionType == 1) return 0.400000;
			if(actionType == 2) return 0.400000;
			if(actionType == 3) return 0.400000;
		}
		else if(PlayerViewMesh == LodMesh'DeusExItems.Shotgun')
		{
			if(actionType == 0) return 1.000000;
			if(actionType == 1) return 0.750000;
			if(actionType == 2) return 0.500000;
			if(actionType == 3) return 0.500000;
		}
		else if(PlayerViewMesh == LodMesh'DeusExItems.AssaultShotgun')
		{
			if(actionType == 0) return 0.727272;
			if(actionType == 1) return 0.600000;
			if(actionType == 2) return 1.000000;
			if(actionType == 3) return 0.428571;
		}
		else if(PlayerViewMesh == LodMesh'DeusExItems.PlasmaRifle')
		{
			if(actionType == 0) return 1.000000;
			if(actionType == 1) return 0.800000;
			if(actionType == 2) return 0.800000;
			if(actionType == 3) return 0.600000;
		}
		else if(PlayerViewMesh == LodMesh'DeusExItems.Sword')
		{
			if(actionType == 0) return 0.888888;
			if(actionType == 1) return 1.000000;
			if(actionType == 2) return -1.000000;
			if(actionType == 3) return -1.000000;
		}
		else if(PlayerViewMesh == LodMesh'DeusExItems.NanoSword')
		{
			if(actionType == 0) return 1.200000;
			if(actionType == 1) return 0.583333;
			if(actionType == 2) return -1.000000;
			if(actionType == 3) return -1.000000;
		}
		else if(PlayerViewMesh == LodMesh'DeusExItems.Shuriken')
		{
			if(actionType == 0) return 0.818181;
			if(actionType == 1) return 0.538461;
			if(actionType == 2) return -1.000000;
			if(actionType == 3) return -1.000000;
		}
		else if(PlayerViewMesh == LodMesh'DeusExItems.EMPGrenade')
		{
			if(actionType == 0) return 1.142857;
			if(actionType == 1) return 1.142857;
			if(actionType == 2) return -1.000000;
			if(actionType == 3) return -1.000000;
		}
		else if(PlayerViewMesh == LodMesh'DeusExItems.GasGrenade')
		{
			if(actionType == 0) return 1.200000;
			if(actionType == 1) return 0.900000;
			if(actionType == 2) return -1.000000;
			if(actionType == 3) return -1.000000;
		}
		else if(PlayerViewMesh == LodMesh'DeusExItems.NanoVirusGrenade')
		{
			if(actionType == 0) return 1.142857;
			if(actionType == 1) return 1.142857;
			if(actionType == 2) return -1.000000;
			if(actionType == 3) return -1.000000;
		}
		else if(PlayerViewMesh == LodMesh'DeusExItems.Baton')
		{
			if(actionType == 0) return 0.933333;
			if(actionType == 1) return 0.750000;
			if(actionType == 2) return -1.000000;
			if(actionType == 3) return -1.000000;
		}
		else
		{
			if((animFrame > 0.000000) && (animRate > 0.000000))
				return (animFrame / animRate);

			return -1.000000;
		}
	}
}

function LaserToggle()
{
	if(bToggleLaser)
	{
		bLasing = !bLasing;
		if(!bLasing)
			LaserOff();
	}
}

function bool GetCli_bFire()
{
	local Pawn cp;

	cp = Pawn(Owner);
	if(cp != None)
		return (cp.bFire == 1);
	else
		return False;
}

function CycleAmmo()
{
	local int i, last, ammotypes;

	If(IsInState('Reload') || IsInState('SimReload'))
		return;

	ammoTypes = NumAmmoTypesAvailable();
	if (ammoTypes < 2)
		return;

	for (i=0; i<ammoTypes; i++)
		if (AmmoNames[i] == AmmoName)
			break;

	last = i;

	do
	{
		if (++i >= ammoTypes)
			i = 0;

		if (LoadAmmo(i))
			break;
	}
	until (last == i);
}

Function bool IsServer()
{
	local DeusExPlayer sOwner;
	sOwner = DeusExPlayer(Owner);
	return ( Level.NetMode == NM_DedicatedServer  || ((Level.NetMode == NM_ListenServer) && sOwner != None && !sOwner.PlayerIsListenClient()));
}

Function bool IsClient()
{
	local DeusExPlayer sOwner;
	sOwner = DeusExPlayer(Owner);
	return ( Level.NetMode == NM_Client ) || ((Level.NetMode == NM_ListenServer) && sOwner != None && sOwner.PlayerIsListenClient());
}

function bool ShouldWaitOnDown()
{
	return (AnimSequence == 'Shoot'		||
			AnimSequence == 'Attack'	||
			AnimSequence == 'Attack1'	||
			AnimSequence == 'Attack2'	||
			AnimSequence == 'Attack3'	||
			AnimSequence == 'Place'		||
			AnimSequence == 'Throw');
}

final Function PushWeaponSwitch()
{
	local Pawn pOwner;

	pOwner = Pawn(Owner);

	if (pOwner != None)
		pOwner.ChangedWeapon();
}

final Function bool NeedReload()
{
	return ((ClipCount >= ReloadCount) && !IsSword() && !IsThrown());
}

final Function Int GetAmmoNum()
{
	local int d;

	if(bHandToHand || AmmoType == None)
		return 0;

	for(d = 0; d < 3; d++)
		if(AmmoType.Class == AmmoNames[d])
			return d;

	return 0;
}

Function SetReloadCount(int ammoNum, optional bool bEmptyClip)
{
	local int ClipMod;
	if(AmmoReload[ammoNum] <= 0)
	{
		if(mpReloadCount != Default.ReloadCount && Level.Netmode != NM_Standalone)
		{
			If(Default.mpReloadCount == 1)
			{
				ReloadCount = 1;

				LowAmmoWatermark = 2;

				if(bEmptyClip)
					ClipCount = 1;
			}
			else
			{
				if((mpReloadCount * 0.1) < 2)
					ClipMod = 1;
				else
					ClipMod = mpReloadCount * 0.1;

				ReloadCount = mpReloadCount + (ClipMod * (ModReloadCount * 10));

				LowAmmoWatermark = ReloadCount * (Default.LowAmmoWatermark / mpReloadCount);

				if(bEmptyClip)
					ClipCount = mpReloadCount + (ClipMod * (ModReloadCount * 10));
			}
		}
		else
		{
			If(Default.ReloadCount == 1)
			{
				ReloadCount = 1;

				LowAmmoWatermark = 2;

				if(bEmptyClip)
					ClipCount = 1;
			}
			else
			{
				if((Default.ReloadCount * 0.1) < 2)
					ClipMod = 1;
				else
					ClipMod = Default.ReloadCount * 0.1;

				ReloadCount = Default.ReloadCount + (ClipMod * (ModReloadCount * 10));

				LowAmmoWatermark = ReloadCount * (Default.LowAmmoWatermark / Default.ReloadCount);

				if(bEmptyClip)
					ClipCount = Default.ReloadCount + (ClipMod * (ModReloadCount * 10));
			}
		}
	}
	else
	{
		if(AmmoReload[ammoNum] > 1)
		{
			if((AmmoReload[ammoNum] * 0.1) < 2)
				ClipMod = 1;
			else
				ClipMod = AmmoReload[ammoNum] * 0.1;

			ReloadCount = AmmoReload[ammoNum] + (ClipMod * (ModReloadCount * 10));

			LowAmmoWatermark = ReloadCount * (Default.LowAmmoWatermark / AmmoReload[ammoNum]);

			if(bEmptyClip)
				ClipCount = AmmoReload[ammoNum] + (ClipMod * (ModReloadCount * 10));
		}
		else
		{
			ReloadCount = 1;

			LowAmmoWatermark = 2;

			if(bEmptyClip)
				ClipCount = 1;
		}
	}
	if(bEmptyClip)
		EndClipReload();
}

function SetAmmoProperties(int ammoNum)
{
	//------
	// Okay. Seriously. Which Deus Ex Dev is responsible for:
	// - Locking the reload time of weapons with projectiles to 2 seconds.
	// - Locking ShotTime to 1.0.
	// - Assuming the weapon will be non-automatic.
	// - Letting the PROJECTILE handle the ShotSound through its' SpawnSound...
	// - and all of this being enforced after switching ammo types.
	// ...
	// I swear this game wasn't as buggy as this when I played it. D:
	// ---
	// Lex-Edit: I've made the fixed variables only apply to 20mm rounds.
	//------

	// if we don't have a projectile for this ammo type, then set instant hit
	if (ProjectileNames[ammoNum] == None)
	{
		bInstantHit = True;
		ShotTime = Default.ShotTime;
		if ( Level.NetMode != NM_Standalone && default.mpReloadTime != -1.000000 )
		{
			if (HasReloadMod())
				ReloadTime = default.mpReloadTime * (1.0+ModReloadTime);
			else
				ReloadTime = default.mpReloadTime;
		}
		else
		{
			if (HasReloadMod())
				ReloadTime = Default.ReloadTime * (1.0+ModReloadTime);
			else
				ReloadTime = Default.ReloadTime;
		}
		FireSound = Default.FireSound;
		ProjectileClass = None;
	}
	else
	{
		// otherwise, set us to fire projectiles
		bInstantHit = False;
		ShotTime = Default.ShotTime;
		if ( Level.NetMode != NM_Standalone )
		{
			if (HasReloadMod())
				ReloadTime = mpReloadTime * (1.0+ModReloadTime);
			else
				ReloadTime = mpReloadTime;
		}
		else
		{
			if (HasReloadMod())
				ReloadTime = Default.ReloadTime * (1.0+ModReloadTime);
			else
				ReloadTime = Default.ReloadTime;
		}
		ProjectileClass = ProjectileNames[ammoNum];
		ProjectileSpeed = ProjectileClass.Default.Speed;
	}
}

function EndClipReload()
{
	local DeusExPlayer dxp;

	dxp = DeusExPlayer(Owner);
	if (NeedReload())
	{
		if (Owner != None)
		{
			bFiring = False;
			if (bHasMuzzleFlash)
				EraseMuzzleFlashTexture();

			if (dxp != None)
			{
				// should we autoreload?
				if (dxp.bAutoReload)
				{
					if(AmmoType.AmmoAmount <= 0)
					{
						if (AmmoType.Class != AmmoNames[0] && AmmoNames[0] != None)
							LoadAmmo(0);
						else
						{
							if(Level.Netmode != NM_Standalone)
								Finish();

							if(!IsInState('Idle'))
								GotoState('Idle');
						}
					}
					else
					{
						ReloadAmmo();
					}
				}
				else
				{
					if(!IsInState('Idle'))
						GotoState('Idle');
				}
			}
			else if (Owner.IsA('ScriptedPawn'))
			{
				ReloadAmmo();
			}
		}
		else
		{
			if(!IsInState('Idle'))
				GotoState('Idle');
		}
	}
}

function ReloadAmmo()
{
	// single use or hand to hand weapon if ReloadCount == 0
	if (ReloadCount == 0 || IsThrown())
	{
		Pawn(Owner).ClientMessage(msgCannotBeReloaded);
		return;
	}

	if (!IsInState('Reload'))
	{
		if(CanReload())
		{
			if(AnimSequence == 'Idle' || AnimSequence == 'Idle1' || AnimSequence == 'Idle2' || AnimSequence == 'Idle3' || AnimSequence == 'Still')
				TweenAnim('Still', 0.0);

			GotoState('Reload');
		}
	}
}

function bool LoadAmmo(int ammoNum)
{
	local class<Ammo> newAmmoClass;
	local Ammo newAmmo;
	local Pawn P;

	if ((ammoNum < 0) || (ammoNum > 2))
		return False;

	P = Pawn(Owner);

	// sorry, only pawns can have weapons
	if (P == None)
		return False;

	newAmmoClass = AmmoNames[ammoNum];

	if (newAmmoClass != None)
	{
		if (newAmmoClass != AmmoName)
		{
			newAmmo = Ammo(P.FindInventoryType(newAmmoClass));
			if((NewAmmo != None && NewAmmo.AmmoAmount == 0 && ammoNum > 0) || NewAmmo == None)
			{
				P.ClientMessage(Sprintf(msgOutOf, newAmmoClass.Default.ItemName));
				return False;
			}

			AmmoName = newAmmoClass;
			AmmoType = newAmmo;

			SetAmmoProperties(ammoNum);
			SetReloadCount(ammoNum, True);

			if (IsServer())
			{
				SetClientAmmoParams2(ShotTime, FireSound, ProjectileClass, ReloadCount, ReloadTime, LowAmmoWatermark);
				ForceClientReload();
			}

			// Notify the object belt of the new ammo
			if (DeusExPlayer(P) != None)
				DeusExPlayer(P).UpdateBeltText(Self);

			P.ClientMessage(Sprintf(msgNowHas, ItemName, newAmmoClass.Default.ItemName));
			return True;
		}
	}
	return False;
}

// Updates laser spot whilst using laser sight by maths - no laser emitter needed.
function UpdateSpot()
{
	local vector loc, norm, tempV[2];
	local rotator lasrot;
	local Actor DotActor;
	local Pawn p;

	p = Pawn(Owner);

	lasrot = P.ViewRotation;
	tempV[1] = P.Location;
	tempV[1].Z += P.BaseEyeHeight;
	tempV[0] = vector(LasRot) * MaxRange;
	tempV[0].Z += P.BaseEyeHeight;
	tempV[0] += P.Location;
	ForEach TraceActors( Class'Actor', DotActor, Loc, Norm, tempV[0], tempV[1] )
	{
		if(DeusExPlayer(DotActor) != None && DeusExPlayer(DotActor).Style == STY_Translucent)
			Continue;
		else
			Break;
	}

	if(lSpot == none)
	{
		lSpot = Spawn(class'LaserPointer',,,loc);
		if(!bVisibleLaser)
		{
			lSpot.SetOwner(P);
			lSpot.bOnlyOwnerSee = True;
		}
	}
	else if(lSpot != None)
	{
		Loc = (vector(LasRot) * ((vSize(tempV[1] - loc)) - 10) ) + P.Location;
		Loc.Z += P.BaseEyeHeight;
		lSpot.SetLocation(Loc);
		lSpot.SetRotation(Rotator(Norm));
	}
}

Function LaserOff()
{
	if(lSpot != None)
	{
		lSpot.Destroy();
		lSpot = None;
	}
}

function PlayFiringSoundEX()
{
	local float pewVolume, pewRadius;
	local Sound pewpewgun;
	
	if(Owner != None)
	{
		pewVolume = TransientSoundVolume;
		
		if(bHasSilencer)
		{
			pewRadius = 1024;
			
			if(SilencedFire != None)
			{
				pewpewgun = SilencedFire;
			}
			else
			{
				pewpewgun = FireSound;
				pewVolume *= 0.333333;
			}
		}
		else
		{
			if(bSoundToRange)
				pewRadius = MaxRange;
			else
				pewRadius = 2048;

			pewpewgun = FireSound;
		}
		
		Owner.PlaySound(pewpewgun, SLOT_None, pewVolume,, pewRadius);
	}
}

/* //residual Cozzzy code
simulated function PlayFiringSound()
{
	//if (bHasSilencer)
	//	PlaySimSound( Sound'StealthPistolFire', SLOT_None, TransientSoundVolume, 2048 );
	//else
	//{
		// The sniper rifle sound is heard to it's range in multiplayer
		if ( ( Level.NetMode != NM_Standalone ) &&  Self.IsA('WeaponRifle') )	
			PlaySimSound( FireSound, SLOT_None, TransientSoundVolume, class'WeaponRifle'.Default.mpMaxRange );
		else
			PlaySimSound( FireSound, SLOT_None, TransientSoundVolume, 2048 );
	//}
}*/

function Fire(float Value)
{
	local float sndVolume;
	local bool bListenClient;
	local DeusExPlayer pOwner;

	pOwner = DeusExPlayer(Owner);

	if(pOwner != None)
		bListenClient = pOwner.PlayerIsListenClient();

	sndVolume = TransientSoundVolume;

	if ( Level.NetMode != NM_Standalone )  // Turn up the sounds a bit in mulitplayer
	{
		sndVolume = TransientSoundVolume * 2.0;
		if(pOwner != None)
		{
			if(pOwner.NintendoImmunityTimeLeft > 0.01 || (!bClientReady && (!bListenClient)) )
			{
				pOwner.bJustFired = False;
				bReadyToFire = True;
				bPointing = False;
				bFiring = False;
				return;
			}
		}
	}

	// check for surrounding environment
	if ((EnviroEffective == ENVEFF_Air) || (EnviroEffective == ENVEFF_Vacuum) || (EnviroEffective == ENVEFF_AirVacuum))
	{
		if (Region.Zone.bWaterZone)
		{
			if (pOwner != None)
			{
				pOwner.ClientMessage(msgNotWorking);
				if (!bHandToHand)
					PlaySimSound( Misc1Sound, SLOT_None, sndVolume, 1024 );		// play dry fire sound
			}
			if(!IsInState('Idle'))
				GotoState('Idle');
			return;
		}
	}

	if (pOwner != None && CanPlaceGrenade())
	{
		if (bNearWall)
		{
			bReadyToFire = False;
			PlayAnim('Place',, 0.1);
			bPointing = True;
			GotoState('NormalFire');
			return;
		}
	}

	if (bHandToHand)
	{
		if (Default.ReloadCount > 0)
			AmmoType.UseAmmo(1);

		if (( Level.NetMode != NM_Standalone ) && !bListenClient )
			bClientReady = False;
		bReadyToFire = False;
		GotoState('NormalFire');
		bPointing = True;
		if ( pOwner != None )
			pOwner.PlayFiring();
		PlaySelectiveFiring();
		PlayFiringSoundEX();
	}
	else if ((ClipCount < ReloadCount) || (ReloadCount == 0))	// if we are a single-use weapon, then our ReloadCount is 0 and we don't use ammo
	{
		if ((ReloadCount == 0) || (Value > 0.000000) || AmmoType.UseAmmo(1))
		{
			if (( Level.NetMode != NM_Standalone ) && !bListenClient )
				bClientReady = False;

			bFiring = True;
			bReadyToFire = False;
			bPointing = True;
			if (( Level.NetMode == NM_Standalone || ( pOwner != None && pOwner.PlayerIsListenClient())) && bShakeViewOn)
			{
				pOwner.ShakeView(ShakeTime, currentAccuracy * ShakeMag + ShakeMag, currentAccuracy * ShakeVert);
			}

			GotoState('NormalFire');

			if(Value == 0.000000)
			{
				ClipCount++;

				if ( bInstantHit )
					TraceFire(currentAccuracy);
				else
					ProjectileFire(ProjectileClass, ProjectileSpeed, bWarnTarget);
			}

			if ( pOwner != None )
				pOwner.PlayFiring();
 
			PlaySelectiveFiring();
			PlayFiringSoundEX();
			if ( Owner.bHidden )
				CheckVisibility();
		}
		else
		{
			EndClipReload();
			PlaySimSound( Misc1Sound, SLOT_None, sndVolume, 1024 );		// play dry fire sound
		}
	}
	else
	{
		EndClipReload();
		PlaySimSound( Misc1Sound, SLOT_None, sndVolume, 1024 );		// play dry fire sound
	}

	// Update ammo count on object belt
	if (pOwner != None)
		pOwner.UpdateBeltText(Self);
}

Event Destroyed()
{
	LaserOff();
	Super.Destroyed();
}

function Finish()
{
	local Pawn pOwner;

	if ( Level.NetMode != NM_Standalone )
		ReadyClientToFire( True );

	if (((Level.Netmode == NM_Standalone && bDestroyOnEmpty) || (Level.Netmode != NM_Standalone && bMPDestroyOnEmpty)) && ((AmmoType != None) && AmmoType.AmmoAmount <= 0))
		Destroy();

	if (bHasMuzzleFlash)
	{
		if(Flash != None)
			Flash.Destroy();
		EraseMuzzleFlashTexture();
	}

	if ( bChangeWeapon )
	{
		GotoState('DownWeapon');
		return;
	}

	if (( Level.NetMode != NM_Standalone ) && IsInState('Active'))
	{
		GotoState('Idle');
		return;
	}

	pOwner = Pawn(Owner);

	if (pOwner == None)
	{
		GotoState('Idle');
		return;
	}

	if ( ScriptedPawn(Owner) != None )
	{
		if ( ((AmmoType == None) || (AmmoType.AmmoAmount <= 0)) && ReloadCount != 0 )
		{
			pOwner.StopFiring();
			pOwner.SwitchToBestWeapon();
		}
		else if (pOwner.bFire != 0)
			Global.Fire(0);
		else if (pOwner.bAltFire != 0)
			Global.AltFire(0);
		else
		{
			pOwner.StopFiring();
			GotoState('Idle');
		}
		return;
	}

	if (IsServer())
	{
		GotoState('Idle');
		return;
	}

	if (((AmmoType == None) || (AmmoType.AmmoAmount <= 0)) || (pOwner.Weapon != self))
		GotoState('Idle');
	else if (pOwner.bFire != 0)
		Global.Fire(0);
	else if (pOwner.bAltFire != 0)
		Global.AltFire(0);
	else 
		GotoState('Idle');
}

function ServerGotoFinishFire()
{
	if(NeedReload() || AmmoType.AmmoAmount == 0)
		GotoState('FinishFire');
}

function name WeaponDamageType()
{
	local name						damageType;
	local Class<DeusExProjectile>	projClass;

	projClass = Class<DeusExProjectile>(ProjectileClass);
	if (bInstantHit)
	{
		if(ammoDamageType[GetAmmoNum()] != '')
		{
			damageType = ammoDamageType[GetAmmoNum()];
		}
		else
		{
			if (StunDuration > 0) // This is this variable's only use. Seriously. StunDuration does NOTHING to NPCs.
				damageType = 'Stunned';
			else
				damageType = 'Shot';
		}
	}
	else if (projClass != None)
		damageType = projClass.Default.damageType;
	else
		damageType = 'None';

	return (damageType);
}

function PlaceGrenade()
{
	local ProjectileThrown gren;
	local float dmgX;
	local DeusExPlayer dxp;
	// We check in six directions (X+, X-, Y+, Y-, Z+, Z-)
	local Actor Obst[6];
	local Vector distan[6], finalPlace, Dum[2];
	local int i;

	dxp = DeusExPlayer(Owner);

	if ( AmmoType.AmmoAmount > 0 )
	{
		gren = ProjectileThrown(spawn(ProjectileClass, Owner,, placeLocation, Rotator(placeNormal)));
		if (gren != None)
		{
			AmmoType.UseAmmo(1);
			if ( AmmoType.AmmoAmount <= 0 )
				bDestroyOnFinish = True;

			if(gren.HasAnim('Open'))
				gren.PlayAnim('Open');

			gren.PlaySound(gren.MiscSound, SLOT_None, 0.5+FRand()*0.5,, 512, 0.85+FRand()*0.3);
			gren.SetPhysics(PHYS_None);
			gren.bBounce = False;
			gren.bProximityTriggered = True;
			gren.bStuck = True;
			if (placeMover != None)
				gren.SetBase(placeMover);

			// up the damage based on the skill
			// returned value from GetWeaponSkill is negative, so negate it to make it positive
			// dmgX value ranges from 1.0 to 2.4 (max demo skill and max target aug)
			dmgX = 2.0 * abs(GetWeaponSkill()) + 1.0;
			gren.Damage *= dmgX;

			// Update ammo count on object belt
			if (dxp != None)
				dxp.UpdateBeltText(Self);
		}
	}
	else
	{
		if (dxp != None)
			dxp.RemoveItemFromSlot(Self);   // remove it from the inventory grid
		Destroy();
	}
}

function BringUp()
{
	local DeusExPlayer dxp;
	local DeusExRootWindow root;

	dxp = DeusExPlayer(Owner);

	if ( dxp != None )
	{
		SetHand(dxp.Handedness);
		if (( Level.NetMode != NM_Standalone ) && (Role == ROLE_Authority))
			ClientSetHandedness( dxp.Handedness );
		dxp.EndZoom();
	}

	if(DeusExPlayer(Owner) != None)
	{
	}
	bWeaponUp = false;
	PlaySelect();
	if(dxp != None)
		EndClipReload();
	GotoState('Active');
}

function PlaySelect()
{
	if(!bQuickSwitch)
		PlayAnim('Select',1.0,0.0);
	Owner.PlaySound(SelectSound, SLOT_Misc, Pawn(Owner).SoundDampening);	
}

function DropFrom(vector StartLocation)
{
	local DeusExPlayer dxp;

	if ( !SetLocation(StartLocation) )
		return;

	if (AmmoType != None)
	{
		if (AmmoType.PickupViewMesh == LodMesh'DeusExItems.TestBox')
		{
			PickupAmmoCount = AmmoType.AmmoAmount;
			AmmoType.AmmoAmount = 0;
		}
		else
			PickupAmmoCount = 0;
	}
	if (Level.Netmode != NM_Standalone)
		bTossedOut = true;

	AmmoReset(False);
	dxp = DeusExPlayer(Owner);

	if(dxp != None && (bZoomed))
		dxp.EndZoom();
	bZoomed = False;
	bWasZoomed = False;

	Super(Inventory).DropFrom(StartLocation);
}

function AmmoReset(bool bEmptySecondary)
{
	local int i;
	local pawn p;
	local DeusExPlayer dxp;

	p = Pawn(Owner);
	dxp = DeusExPlayer(Owner);

	if(NumAmmoTypesAvailable() > 1 && P != None && GetAmmoNum() != 0) // Force reset to ammo type 0.
	{
		if (AmmoNames[0] != None)
		{
			if (AmmoNames[0] != AmmoName)
			{
				if(bEmptySecondary)
				{
					for (i = 1; i < 3; i++)
					{
						if(AmmoNames[i] != None)
						{
							AmmoType = Ammo(P.FindInventoryType(AmmoNames[i]));
							if(AmmoType != None)
							{
								AmmoType.AmmoAmount = 0;
							}
						}
					}
				}
				AmmoName = AmmoNames[0];
				AmmoType = Ammo(P.FindInventoryType(AmmoNames[0]));
				if(AmmoType == None)
				{
					GiveAmmo(P);
					AmmoType = Ammo(P.FindInventoryType(AmmoNames[0]));
				}

				SetAmmoProperties(0);
				SetReloadCount(0, False);

				if (IsServer())
				{
					SetClientAmmoParams2(ShotTime, FireSound, ProjectileClass, ReloadCount, ReloadTime, LowAmmoWatermark);
					if(ReloadCount > AmmoType.AmmoAmount)
						ClipCount = ReloadCount - AmmoType.AmmoAmount;
					else
						ClipCount = 0;
				}

				// Notify the object belt of the new ammo
				if (DXP != None)
					DXP.UpdateBeltText(Self);
			}
		}
	}
}

// Migrate the environment effectiveness code here too.
function GenerateBullet()
{
	local pawn P;

	p = Pawn(Owner);

	if ((EnviroEffective == ENVEFF_Air) || (EnviroEffective == ENVEFF_Vacuum) || (EnviroEffective == ENVEFF_AirVacuum))
	{
		if (Region.Zone.bWaterZone)
		{
			if (P != None)
			{
				P.ClientMessage(msgNotWorking);
				if (!bHandToHand)
					PlaySimSound( Misc1Sound, SLOT_None, TransientSoundVolume * 2.0, 1024 );
			}
			return;
		}
	}
	if (AmmoType.UseAmmo(1))
	{
		if ( bInstantHit )
			TraceFire(currentAccuracy);
		else
			ProjectileFire(ProjectileClass, ProjectileSpeed, bWarnTarget);

		ClipCount++;
	}
	else
		GotoState('FinishFire');
}

function repH2HA()
{
	local ScriptedPawn sp;

	if (bOwnerWillNotify || bLockH2HA)
		return;

	bLockH2HA = True;
	sp = ScriptedPawn(Owner);
	if (sp != None)
		sp.SetAttackAngle();

	if (bInstantHit)
		TraceFire(0.0);
	else
		ProjectileFire(ProjectileClass, ProjectileSpeed, bWarnTarget);

	// if we are a thrown weapon and we run out of ammo, destroy the weapon
	if (Level.Netmode != NM_Standalone && ((ReloadCount > 0) && (SimAmmoAmount <= 0)) && bMPDestroyOnEmpty)
	{
		DestroyOnFinish();
		if(IsClient())
			GoToState('SimQuickFinish');
	}
}

function float GetReloadTime()
{
	local float val;

	val = ReloadTime;

	if(DeusExPlayer(Owner) != None)
	{
		// check for skill use if we are the player
		val = GetWeaponSkill();
		val = ReloadTime + (val * ReloadTime);
	}

	return val;
}

/*
//==================================================\\
|| NORMAL STATES									||
|| (Excessive code a go-go!)						||
\\==================================================//
*/

State Idle2
{
	function BeginState()
	{
		AmmoReset(True);
		ResetHDTP();
	}
}

state FinishFire
{
Begin:
	bFiring = False;
	if (((Level.Netmode == NM_Standalone && bDestroyOnEmpty) || (Level.Netmode != NM_Standalone && bMPDestroyOnEmpty)) && ((AmmoType != None) && AmmoType.AmmoAmount <= 0))
		Destroy();
	else
		Finish();
}

state NormalFire
{
	function AnimEnd()
	{
		// if we are a thrown weapon and we run out of ammo, destroy the weapon
		if (bHandToHand && (ReloadCount > 0) && (AmmoType.AmmoAmount <= 0) && ((Level.Netmode == NM_Standalone && bDestroyOnEmpty) || (Level.Netmode != NM_Standalone && bMPDestroyOnEmpty)))
		{
			Destroy();
		}
	}

	function ReloadAmmo()
	{
		if(!bLockCFire)
			Global.ReloadAmmo();
	}

	function float GetShotTime()
	{
		local float mult, sTime;
		local DeusExPlayer dxp;

		if (!bHandToHand || ScriptedPawn(Owner) != None)
		{
			return ShotTime;
		}
		else
		{
			// AugCombat decreases shot time
			mult = 1.0;
			dxp = DeusExPlayer(Owner);
			if (dxp != None && bHandToHand && (CombatStrSetting == COMSTR_Speed || CombatStrSetting == COMSTR_PowSpeed))
			{
				mult = 1.0 / dxp.AugmentationSystem.GetAugLevelValue(class'AugCombat');
				if (mult == -1.0)
					mult = 1.0;
			}
			sTime = ShotTime * mult;
			return (sTime);
		}
	}

	event EndState()
	{
		LockClientFiring(False);
		bLockCFire = False;
		bLockH2HA = False;
	}

Begin:
	LockClientFiring(True);
	bLockCFire = True;
	AddRecoilTime();
	if(bHasScope && bZoomed && NeedReload() && DeusExPlayer(Owner) != None)
	{
		if(ScopeDownDelay > 0.000000 && ScopeDownDelay < GetShotTime())
		{
			Sleep(ScopeDownDelay);
			bZoomed = False;
			RefreshScopeDisplay(DeusExPlayer(Owner), False, False);
			if(AmmoType.AmmoAmount > 0)
				bWasZoomed = True;
			Sleep(GetShotTime() - ScopeDownDelay);
		}
		else
		{
			Sleep(GetShotTime());
			bZoomed = False;
			RefreshScopeDisplay(DeusExPlayer(Owner), False, False);
			if(AmmoType.AmmoAmount > 0)
				bWasZoomed = True;
		}
	}
	else
	{
		if(bHandToHand)
		{
			if(CanPlaceGrenade() && bNearWall)
				Sleep(placeTime);
			else
			{
				if(H2HDelay < 1.0 || H2HDelay > 0.0)
				{
					Sleep(GetShotTime() * H2HDelay);
					repH2HA();
					Sleep(GetShotTime() * (1.0 - H2HDelay));
				}
				else
				{
					Sleep(GetShotTime());
				}
			}
		}
		else
		{
			Sleep(GetShotTime());
		}
	}

	if(Level.Netmode == NM_Standalone)
		FinishAnim();

	LockClientFiring(False);
	bLockCFire = False;
	bLockH2HA = False;
	EndClipReload();
	ReadyToFire();
	bFiring = False;
	bCli_bFire = False;
	Finish();
}

state DownWeapon
{
ignores Fire, AltFire;

	function EndState()
	{
		downReloadDelay = 0.000000;
	}

	function bool PutDown()
	{
		// alert NPCs that I'm putting away my gun
		AIEndEvent('WeaponDrawn', EAITYPE_Visual);
		return true;
	}

	function BeginState()
	{
		bChangeWeapon = false;
		bMuzzleFlash = 0;
	}

	function Tick(float Deltatime)
	{
		Global.Tick(Deltatime);

		if((Level.Netmode != NM_Standalone) && bReloadDownSniper && (ReloadCount == 1 && ClipCount == 1) && !bOnlyOwnerSee)
		{
			downReloadDelay += Deltatime;
			if(downReloadDelay >= (GetReloadTime() + GetAnimationSleepTime(2) + GetAnimationSleepTime(3)))
			{
				ClipCount = 0;
			}
		}
	}
Begin:
	if(!bQuickSwitch)
	{
		togDownState(False);
		ScopeOff();
		bWasZoomed = False;

		if(bHasMuzzleFlash)
		{
			If(Flash != None)
				Flash.Destroy();
			EraseMuzzleFlashTexture();
		}

		if (ScriptedPawn(Owner) != None)
		{
			Pawn(Owner).ChangedWeapon();
		}
		else if (( Level.NetMode == NM_DedicatedServer ) || ((Level.NetMode == NM_ListenServer) && Owner.IsA('DeusExPlayer') && !DeusExPlayer(Owner).PlayerIsListenClient()))
		{
			ClientDownWeapon();
			Sleep(GetAnimationSleepTime(1) * 0.5); // Something in the old Engine.Weapon code sets holstering animations to 2x speed.
		}
		else if(Level.Netmode == NM_StandAlone || (Level.NetMode == NM_ListenServer && Owner.IsA('DeusExPlayer') && DeusExPlayer(Owner).PlayerIsListenClient()))
		{
			if(ShouldWaitOnDown())
				FinishAnim();

			TweenDown();
			FinishAnim();
			if (Pawn(Owner) != None)
				Pawn(Owner).ChangedWeapon();
		}

		if(Level.Netmode != NM_Standalone && bSwitchReload && ReloadCount > 1)
			ClipCount = 0;
			
		togDownState(True);
		bOnlyOwnerSee = false;
	}
	else
	{
		ScopeOff();
		bWasZoomed = False;

		if(bHasMuzzleFlash)
		{
			If(Flash != None)
				Flash.Destroy();
			EraseMuzzleFlashTexture();
		}
		if (ScriptedPawn(Owner) != None)
		{
			Pawn(Owner).ChangedWeapon();
		}
		else if (( Level.NetMode == NM_DedicatedServer ) || ((Level.NetMode == NM_ListenServer) && Owner.IsA('DeusExPlayer') && !DeusExPlayer(Owner).PlayerIsListenClient()))
		{
			ClientDownWeapon();
		}
		else if(Level.Netmode == NM_StandAlone || (Level.NetMode == NM_ListenServer && Owner.IsA('DeusExPlayer') && DeusExPlayer(Owner).PlayerIsListenClient()))
		{
			if (Pawn(Owner) != None)
				Pawn(Owner).ChangedWeapon();
		}

		if(Level.Netmode != NM_Standalone && bSwitchReload && ReloadCount > 1)
			ClipCount = 0;
			
		bOnlyOwnerSee = false;
	}
}

state Reload
{
	ignores AltFire, ReloadAmmo;

	// EDIT:
	// ---
	// Manual-feed reloading weapons (Shotguns, bolt-action rifles, etc) can now
	// have a shot fired during reloading, provided there is ammunition in the gun.
	// Cool, huh? >(^.^)<
	// ---
	// Sadly, I have no idea how to actually get the firing mid-reload to work with AI bots.

	function NotifyOwner(bool bStart)
	{
		local DeusExPlayer player;
		local ScriptedPawn pawn;

		player = DeusExPlayer(Owner);
		pawn   = ScriptedPawn(Owner);

		if(player != None)
		{
			if(bStart)
				player.Reloading(self, GetReloadTime());
			else
				player.DoneReloading(self);
		}
		else if(pawn != None)
		{
			if(bStart)
				pawn.Reloading(self, GetReloadTime());
			else
				pawn.DoneReloading(self);
		}
	}

Begin:
	if(Level.Netmode == NM_Standalone)
	{
		if(AnimSequence == 'Shoot' || (bHandToHand && (AnimSequence == 'Throw' || AnimSequence == 'Attack' || AnimSequence == 'Attack2' || AnimSequence == 'Attack3')))
			FinishAnim();
		else
			TweenAnim('Still',0.0);
	}

	if(!bOldAccuDecay)
		StandingTimer = 0.0;

	if (bHasMuzzleFlash)
		EraseMuzzleFlashTexture();

	// only reload if we have ammo left
	if((AmmoType.AmmoAmount > 0) && ClipCount > 0 && (AmmoType.AmmoAmount - (ReloadCount - ClipCount) > 0 ))
	{
		if(ScriptedPawn(Owner) != None)
		{
			NotifyOwner(True);
			Owner.PlaySound(CockingSound, SLOT_None,,, 1024);		// Begin reload noise
			Sleep(GetReloadTime());
			if(ReloadCount > AmmoType.AmmoAmount)
				ClipCount = ReloadCount - AmmoType.AmmoAmount;
			else
				ClipCount = 0;
			Owner.PlaySound(AltFireSound, SLOT_None,,, 1024);		// End reload noise.
			Sleep(0.45);
			NotifyOwner(False);
		}
		else if(IsServer())
		{
			if(!bWasZoomed)
				bWasZoomed = bZoomed;

			if(bWasZoomed)
			{
				bZoomed = False;
				if(ScopeDownDelay <= 0.000000)	// ScopeDownDelay handles the dropping of the scope via NormalFire.
					RefreshScopeDisplay(DeusExPlayer(Owner), False, False);
			}
			ClientReload();
			NotifyOwner(True);
			togReloadState(False);
			Owner.PlaySound(CockingSound, SLOT_None,,, 1024);		// CockingSound is reloadbegin
			Sleep(GetAnimationSleepTime(2));
			Sleep(GetReloadTime());
			if(ReloadCount > AmmoType.AmmoAmount)
				ClipCount = ReloadCount - AmmoType.AmmoAmount;
			else
				ClipCount = 0;
			Owner.PlaySound(AltFireSound, SLOT_None,,, 1024);		// AltFireSound is reloadend
			TogReloadState(True);
			Sleep(GetAnimationSleepTime(3));
			TogReloadState(False);
			NotifyOwner(False);
			ReadyClientToFire(True);

			if (bWasZoomed)
			{
				bZoomed = True;
				RefreshScopeDisplay(DeusExPlayer(Owner), False, True);
				bWasZoomed = False;
			}
		}
		else
		{
			if(!bWasZoomed)
				bWasZoomed = bZoomed;

			if(bWasZoomed)
			{
				bZoomed = False;
				if(ScopeDownDelay <= 0.000000)
					RefreshScopeDisplay(DeusExPlayer(Owner), False, False);
			}
			Owner.PlaySound(CockingSound, SLOT_None,,, 1024);		// CockingSound is reloadbegin
			PlayAnim('ReloadBegin');
			NotifyOwner(True);
			FinishAnim();
			LoopAnim('Reload');
			Sleep(GetReloadTime());
			Owner.PlaySound(AltFireSound, SLOT_None,,, 1024);		// AltFireSound is reloadend
			if(ReloadCount > AmmoType.AmmoAmount)
				ClipCount = ReloadCount - AmmoType.AmmoAmount;
			else
				ClipCount = 0;
			PlayAnim('ReloadEnd');
			FinishAnim();
			NotifyOwner(False);

			if (bWasZoomed)
			{
				ScopeOn();
				bWasZoomed = False; // Important for Sniper/GEP scope fix.
			}
		}
	}
	GotoState('Idle');
}

state Active
{
	function bool PutDown()
	{
		// alert NPCs that I'm putting away my gun
		AIEndEvent('WeaponDrawn', EAITYPE_Visual);
		return Super.PutDown();
	}

Begin:
	// Rely on client to fire if we are a multiplayer client

	if(!bQuickSwitch)
	{
		if ( (Level.NetMode==NM_Standalone) || (Owner.IsA('DeusExPlayer') && DeusExPlayer(Owner).PlayerIsListenClient()) )
		{
			bClientReady = True;
			FinishAnim();
		}
		if (( Level.NetMode == NM_DedicatedServer ) || ((Level.NetMode == NM_ListenServer) && Owner.IsA('DeusExPlayer') && !DeusExPlayer(Owner).PlayerIsListenClient()))
		{
			ClientActive();
			Sleep(GetAnimationSleepTime(0) * 0.85);
			togSelectState(False);
			bClientReady = False;
		}

		if ( bChangeWeapon )
			GotoState('DownWeapon');

		bWeaponUp = True;
		if(Pawn(Owner).IsA('ScriptedPawn'))
		{
			bReadyToFire = True;
			bFiring = False;
			bPointing = True;
		}
		PlayPostSelect();
		togSelectState(True);
		EndClipReload();
		Finish();
	}
	else
	{
		if ( (Level.NetMode==NM_Standalone) || (Owner.IsA('DeusExPlayer') && DeusExPlayer(Owner).PlayerIsListenClient()) )
			bClientReady = True;
		if (( Level.NetMode == NM_DedicatedServer ) || ((Level.NetMode == NM_ListenServer) && Owner.IsA('DeusExPlayer') && !DeusExPlayer(Owner).PlayerIsListenClient()))
		{
			ClientActive();
			bClientReady = False;
		}
		if ( bChangeWeapon )
			GotoState('DownWeapon');

		bWeaponUp = True;
		if(Pawn(Owner).IsA('ScriptedPawn'))
		{
			bReadyToFire = True;
			bFiring = False;
			bPointing = True;
		}
		EndClipReload();
		Finish();
	}
}

/*
//==================================================\\
|| SIMULATED STATES									||
|| (Most of these are lots of doing nothing...)		||
\\==================================================//
*/

simulated state SimReload
{
	ignores Fire, AltFire, ClientRefire, ReloadAmmo;

Begin:
	if(AnimSequence == 'Shoot' || AnimSequence == 'Place')
		FinishAnim();
	else
		TweenAnim('Still',0.0);

	if(!bOldAccuDecay)
		StandingTimer = 0.0;

	if (bHasMuzzleFlash)
		EraseMuzzleFlashTexture();

	bInProcess = False;
	bFiring = False;
	PlayAnim('ReloadBegin');
	FinishAnim();
	LoopAnim('Reload');
	While(!bReloadFinished)
	{
		Sleep(0.0);
	}

	while(ClipCount > 0 && (ClipCount != (ReloadCount - AmmoType.AmmoAmount)))
	{
		Sleep(0);
	}
	
	PlayAnim('ReloadEnd');
	FinishAnim();
	While(bReloadFinished)
	{
		Sleep(0.0);
	}
	
	bInProcess = False;
	bFiring = False;
	GotoState('SimIdle');
}

simulated state SimDownWeapon
{
	ignores Fire, AltFire, ClientFire, ClientReFire;

Begin:
	if(!bQuickSwitch)
	{
		if ( bWasInFiring ) 
		{
			if (bHasMuzzleFlash)
				EraseMuzzleFlashTexture();

			FinishAnim();
		}
		bInProcess = False;
		bFiring = False;
		TweenDown();
		FinishAnim();

		while(!bDownFinished)
		{
			Sleep(0.0);
		}

		PushWeaponSwitch();
	}
	else
	{
		if ( bWasInFiring ) 
		{
			if (bHasMuzzleFlash)
				EraseMuzzleFlashTexture();
		}
		bInProcess = False;
		bFiring = False;
		PushWeaponSwitch();
	}
}

simulated state SimQuickFinish
{
Begin:
	if ( IsAnimating() && (AnimSequence == 'Shoot') )
		FinishAnim();

	if (bHasMuzzleFlash)
		EraseMuzzleFlashTexture();

	bInProcess = False;
	bFiring = False;
	if(AmmoType.AmmoAmount == 0)
	{
		GoToState('SimIdle');
	}
}

simulated state ClientFiring
{
	simulated function ReloadAmmo()
	{
		if(AnimSequence != 'Shoot' || AnimSequence != 'Select')
			Global.ReloadAmmo();
	}

	simulated function AnimEnd()
	{
		// if we are a thrown weapon and we run out of ammo, destroy the weapon
		if (bHandToHand && (ReloadCount > 0) && (AmmoType.AmmoAmount <= 0) && bMPDestroyOnEmpty)
		{
			Destroy();
		}
	}

	simulated function float GetSimShotTime()
	{
		local float mult, sTime;
		local DeusExPlayer dxp;

		if (!bHandToHand)
		{
			return ShotTime;
		}
		else
		{
			// AugCombat decreases shot time
			mult = 1.0;
			dxp = DeusExPlayer(Owner);
			if (bHandToHand && dxp != None && (CombatStrSetting == COMSTR_Speed || CombatStrSetting == COMSTR_PowSpeed))
			{
				mult = 1.0 / dxp.AugmentationSystem.GetAugLevelValue(class'AugCombat');
				if (mult == -1.0)
					mult = 1.0;
			}
			sTime = ShotTime * mult;
			return (sTime);
		}
	}

Begin:
	// Thanks ANNA code! :3
	if( IsThrown() && ReloadCount != 1 )
	{
		if(DeusExPlayer(Owner) != None)
			BroadcastMessage("|P2Hey, everyone! " $ DeusExPlayer(Owner).PlayerReplicationInfo.PlayerName @ "|P2is cheating! |P3(Non-standard ReloadCount variable)");

		ReloadCount = 1;
	}
	if(CanPlaceGrenade() && bNearWall)
		Sleep(placeTime);
	else
		Sleep(GetSimShotTime());
	FinishAnim();

	While(bClientCantFire)
		Sleep(0);
	SimEndClipReload();
	bInProcess = False;
	bFiring = False;
	SimFinish();
}

simulated state SimActive
{
Begin:
	if (!bQuickSwitch)
	{
		if ( bWasInFiring )
		{
			if (bHasMuzzleFlash)
				EraseMuzzleFlashTexture();
			FinishAnim();
		}
		bInProcess = False;
		bFiring=False;
		PlayAnim('Select',1.0,0.0);
		FinishAnim();
		while(!bSelectFinished)
		{
			Sleep(0);
		}
		SimFinish();
	}
	else
	{
		if (bHasMuzzleFlash)
			EraseMuzzleFlashTexture();
		bInProcess = False;
		bFiring=False;
		SimFinish();
	}
}

/*
//==================================================\\
|| STUBBED FUNCTIONS								||
\\==================================================//
*/

Simulated function HandToHandAttack(); // Stubbed for being called through meshes.
simulated function OwnerHandToHandAttack(); // Stubbed for uselessness.
function ServerHandleNotify( bool bInstantHit, class<projectile> ProjClass, float ProjSpeed, bool bWarn ); // Stubbed for security.
simulated function AltFire(Float Value); // Stubbed to save your bullets.
simulated function SimGenerateBullet(); // Stubbed due to server-side firing making it redundant.

defaultproperties
{
     ScopeFOV=25
     coneSlugs=5
     BurstShots=1
     recoilTime=-1.000000
     ShotPenaltyMult=1.000000
     ScopeDownDelay=-1.000000
     H2HDelay=0.550000
     ammoReload(0)=-1
     ammoReload(1)=-1
     ammoReload(2)=-1
     SilencedFire=Sound'DeusExSounds.Weapons.StealthPistolFire'
     ManualRoundFeed=Sound'DeusExSounds.Generic.KeyboardClick2'
     bSwitchReload=True
     bOldAccuDecay=True
     bOldConeSpread=True
     bReloadDownSniper=True
	 bUseHDTP=False
     HDTP1st="[NULL]"
     HDTP3rd="[NULL]"
     HDTPPickup="[NULL]"
     mpReloadTime=-1.000000
     mpReloadCount=-1
}
