//=============================================================================
// FireBurstEXFR:
//=============================================================================
//   Client-side particle effect for players upon being ignited.
//=============================================================================

class FireBurstEXFR extends Effects;

var vector initialLocation;
var float rotatorHelper;
var float risingMult;

auto simulated state Flying
{
	simulated function Tick(float delta_time)
	{
		local float intensity, f1, f2;
		local Rotator rot;
		local Vector vec;
		
		intensity = LifeSpan / Default.LifeSpan;
		
		// Opacity fading
		f1 = Sin(intensity * Pi * 0.5);
		f2 = Sin((1.0 - intensity) * Pi * 0.5);
		DrawScale = OddsOfAppearing * intensity * 0.6 + 0.125;
		ScaleGlow = 3.0 * (f2 - (1.0 - f1));
		
		// Force location to the player
		initialLocation = Owner.Location;
		initialLocation.z -= 30.0;
		rot.Yaw = 8192 * rotatorHelper;
		vec.x = 33.0;
		vec.z = 15.0 + (risingMult * 70.0);
		SetLocation((intensity) * (initialLocation) + (1.0 - intensity) * (initialLocation + (vec >> rot)));
	}
}

function InitializeMe(int input)
{
	rotatorHelper = input;
	if(rotatorHelper < 0.0)
	{
		rotatorHelper += 8.0;
		risingMult = 1.0;
	}
}

defaultproperties
{
	rotatorHelper=0.000000
	risingMult=0.000000
	LifeSpan=0.450000
	DrawType=DT_Sprite
	Style=STY_Translucent
	bUnlit=True
}