//=============================================================================
// GasGrenade.
//=============================================================================
class ProjectileGasGrenade extends ProjectileThrown;

var float	mpBlastRadius;
var float	mpProxRadius;
var float	mpGasDamage;
var float	mpFuselength;

simulated function PreBeginPlay()
{
	Super.PreBeginPlay();

	if ( Level.NetMode != NM_Standalone )
	{
		blastRadius=mpBlastRadius;
		proxRadius=mpProxRadius;
		Damage=mpGasDamage;
		fuseLength=mpFuseLength;
		bIgnoresNanoDefense=True;
	}
}

//Added by Cozmo. Don't let teammates shoot your nades!
simulated function TakeDamage(int Damage, Pawn instigatedBy, Vector HitLocation, Vector Momentum, name damageType)
{
	local ProjectileThrown pt;
	
	if(TeamDMGame(Level.Game) != None && Owner != None && instigatedBy != None && instigatedBy != Owner)
	{
		if(instigatedBy.PlayerReplicationInfo.Team == Pawn(Owner).PlayerReplicationInfo.Team)
		{
			if(damageType != 'Exploded')
				return;
		}
	}
	
	/* owner is set, but it still gives the kill to the original placer? (fun: I even tried spawning a second, identical nade belonging to instigatedBy, and even *that* somehow gave the kill to the wrong person...) will come back to this...
	if(instigatedBy.IsA('DeusExPlayer'))
		SetOwner(instigatedBy);
	*/
	
	Super.TakeDamage(Damage, instigatedBy, HitLocation, Momentum, damageType);
}

defaultproperties
{
     mpBlastRadius=512.000000
     mpProxRadius=128.000000
     mpGasDamage=15.000000
     mpFuselength=1.500000
     fuseLength=3.000000
     proxRadius=128.000000
     AISoundLevel=0.000000
     bBlood=False
     bDebris=False
     DamageType=TearGas
     spawnWeaponClass=Class'CDX_140.WeaponGasGrenade2'
     ItemName="Gas Grenade"
     speed=1000.000000
     MaxSpeed=1000.000000
     Damage=10.000000
     MomentumTransfer=50000
     ImpactSound=Sound'DeusExSounds.Weapons.GasGrenadeExplode'
     LifeSpan=0.000000
     Mesh=LodMesh'DeusExItems.GasGrenadePickup'
     CollisionRadius=4.300000
     CollisionHeight=1.400000
     Mass=5.000000
     Buoyancy=2.000000
}
